//archer HUD

#include "ArcherCommon.as";
#include "ActorHUDStartPos.as";

const string iconsFilename = "Entities/Characters/Archer/ArcherIcons.png";

void onInit( CSprite@ this )
{
	this.getCurrentScript().runFlags |= Script::tick_myplayer;
	this.getCurrentScript().removeIfTag = "dead";
}

void ManageCursors( CBlob@ this )
{
	// set cursor
	if (getHUD().hasButtons()) {
		getHUD().SetDefaultCursor();
	}
	else
	{
		// set cursor
		getHUD().SetCursorImage("Entities/Characters/Archer/ArcherCursor.png", Vec2f(32,32));
		getHUD().SetCursorOffset( Vec2f(-32, -32) );
	}
}

void onRender( CSprite@ this )
{
	if (g_videorecording)
		return;

    CBlob@ blob = this.getBlob();

	ManageCursors( blob );

    blob.set_u8("gui_HUD_slots_width", 2);
    int num_arrows = 0;
    int arrow_frame = 0;
    int num_satchels = 0;
    
    u8 type = blob.get_u8("arrow type");
    if (type == ArrowType::normal)
    {
		num_arrows = blob.getBlobCount("mat_arrows");
		arrow_frame = 0;
	}
	else if (type == ArrowType::fire)
	{
		num_arrows = blob.getBlobCount("mat_firearrows");
		arrow_frame = 3;
	}
		
    num_satchels = blob.getBlobCount("satchel");
    //render all relevant info into the bottom HUD rectangle:
    Vec2f tl = getActorHUDStartPosition(blob);
    SColor read_color;
    GUI::DrawIcon( iconsFilename, arrow_frame, Vec2f(16,32), tl+Vec2f(0,-16), 1.0f);
    read_color = num_arrows > 20 ? SColor(255,255,255,255) :
                 num_arrows > 10 ? SColor(255,255,255,128) :
                 num_arrows > 5 ? SColor(255,255,128,0) : SColor(255,255,0,0);
    GUI::DrawText(""+num_arrows, tl +Vec2f(16,24),read_color );
    GUI::DrawIcon( iconsFilename, 1, Vec2f(16,32), tl+Vec2f(32,-16), 1.0f);
    read_color = num_satchels > 1 ? SColor(255,255,255,255) :
                 num_satchels > 0 ? SColor(255,255,255,128) : SColor(255,255,0,0);
    GUI::DrawText(""+num_satchels, tl +Vec2f(48,24),read_color );
}

