#define SERVER_ONLY

void onInit( CBlob@ this )
{
	this.getCurrentScript().tickFrequency = 12;
	this.getCurrentScript().removeIfTag = "dead";
}

void Take( CBlob@ this, CBlob@ blob )
{
    const string blobName = blob.getName();

    if (blobName == "mat_gold" || blobName == "mat_stone" ||
            blobName == "mat_wood" /*|| blobName == "grain"*/)
    {
        if (getGameTime() > blob.get_u32( "autopick time")) {
            if (!this.server_PutInInventory( blob ))
            {
                // we couldn't fit it in
            }
        }
    }
}

void onCollision( CBlob@ this, CBlob@ blob, bool solid )
{
    if (blob is null || blob.getShape().vellen > 1.0f) {
        return;
    }

    Take( this, blob );
}

void onTick( CBlob@ this )
{
	CBlob@[] overlapping;

	if (this.getOverlapping( @overlapping ))
	{
		for (uint i = 0; i < overlapping.length; i++)
		{
			CBlob@ blob = overlapping[i];
			{
				if (blob.getShape().vellen > 1.0f) {
					continue;
				}

				Take( this, blob );
			}
		}
	}
}

// make ignore collision time a lot longer for auto-pickup stuff
void IgnoreCollisionLonger( CBlob@ this, CBlob@ blob )
{
    const string blobName = blob.getName();

    if (blobName == "mat_gold" || blobName == "mat_stone" ||
            blobName == "mat_wood" || blobName == "grain")
    {
        blob.set_u32( "autopick time", getGameTime() +  getTicksASecond() * 12 );
    }
}


void onDetach( CBlob@ this, CBlob@ detached, AttachmentPoint@ attachedPoint )
{
    IgnoreCollisionLonger( this, detached );
}

void onRemoveFromInventory( CBlob@ this, CBlob@ blob )
{
    IgnoreCollisionLonger( this, blob );
}
