#include "/Entities/Common/Building/BuildBlock.as"

shared class HitData
{
    u16 blobID;
    Vec2f tilepos;
};

CBlob@ server_BuildBlob( CBlob@ this, BuildBlock[]@ blocks, uint index )
{
    if (!getNet().isServer() || index >= blocks.length) {
        return null;
    }

	CInventory@ inv = this.getInventory();
    BuildBlock@ b = blocks[index];
    this.set_TileType( "buildtile", 0 );
    CBlob@ anotherBlob = inv.getItem( b.name );

    if (anotherBlob !is null)   {
        this.server_Pickup( anotherBlob );
        this.set_u8( "buildblob", 255 );
        return null;
    }

    CBitStream missing;	
    if (inv.hasRequirements( b.reqs, missing ))
    {
		if (b.buildOnGround)
		{
			if (!this.isOnGround() || getMap().getSectorAtPosition( this.getPosition(), "no build") !is null)
			{
				this.getSprite().PlaySound("/NoAmmo" );
				return null;
			}
			this.getSprite().PlaySound("/Construct" );
			// take inv here instead of in onDetach
			inv.server_TakeRequirements( b.reqs );
		}

        CBlob@ blockBlob = server_CreateBlob( b.name, this.getTeamNum(), this.getPosition() );

        if (blockBlob !is null)
        {
            this.server_Pickup( blockBlob );
            this.set_u8( "buildblob", index );

            if (b.temporaryBlob) {
                blockBlob.Tag("temp blob");
            }

            return blockBlob;
        }
    }

    return null;
}