//archer HUD

#include "/Entities/Common/GUI/ActorHUDStartPos.as";

const string iconsFilename = "Entities/Characters/Builder/BuilderIcons.png";

void onInit( CSprite@ this )
{
	this.getCurrentScript().runFlags |= Script::tick_myplayer;
	this.getCurrentScript().removeIfTag = "dead";
}

void ManageCursors( CBlob@ this )
{
	// set cursor
	if (getHUD().hasButtons()) {
		getHUD().SetDefaultCursor();
	}
	else {
		if (this.isAttached() && this.isAttachedToPoint("GUNNER")) {
			getHUD().SetCursorImage("Entities/Characters/Archer/ArcherCursor.png", Vec2f(32,32));
			getHUD().SetCursorOffset( Vec2f(-32, -32) );
		}
		else {
			getHUD().SetCursorImage("Entities/Characters/Builder/BuilderCursor.png");
		}

	}
}

void onRender( CSprite@ this )
{
	if (g_videorecording)
		return;

    CBlob@ blob = this.getBlob();

	ManageCursors( blob );

    blob.set_u8("gui_HUD_slots_width", 3);
    int num_wood = 0;
    int num_stone = 0;
    int num_gold = 0;
    num_wood = blob.getBlobCount("mat_wood");
    num_stone = blob.getBlobCount("mat_stone");
    num_gold = blob.getBlobCount("mat_gold");
    //render all relevant info into the bottom HUD rectangle:
    Vec2f tl = getActorHUDStartPosition(blob);
    SColor col;
    u32 modGameTime = (getGameTime() % 30);
    //draw wood text + icon
    GUI::DrawIcon( iconsFilename, 0, Vec2f(16,32), tl+Vec2f(0,-16), 1.0f);
    col = num_wood > 100 ? SColor(255,255,255,255) :
          num_wood > 50 ? SColor(255,255,255,128) :
          num_wood > 10 ? SColor(255,255,128,0) : SColor(255,255,0,0);

    if (num_wood > 0 || modGameTime > 10) {
        GUI::DrawText(""+num_wood, tl +Vec2f(8,24),col );
    }

    //draw stone text + icon
    GUI::DrawIcon(iconsFilename, 1, Vec2f(16,32), tl+Vec2f(32,-16), 1.0f);
    col = num_stone > 100 ? SColor(255,255,255,255) :
          num_stone > 50 ? SColor(255,255,255,128) :
          num_stone > 10 ? SColor(255,255,128,0) : SColor(255,255,0,0);

    if (num_stone > 0 || modGameTime > 10) {
        GUI::DrawText(""+num_stone, tl +Vec2f(40,24),col );
    }

    //draw gold text + icon
    GUI::DrawIcon(iconsFilename, 2, Vec2f(16,32), tl+Vec2f(64,-16), 1.0f);
    col = num_gold > 100 ? SColor(255,255,255,255) :
          num_gold > 50 ? SColor(255,255,255,128) :
          num_gold > 10 ? SColor(255,255,128,0) : SColor(255,255,0,0);

    if (num_gold > 0 || modGameTime > 10) {
        GUI::DrawText(""+num_gold, tl +Vec2f(72,24),col );
    }

    //GUI::DrawIcon("Entities/Characters/Builder/BuilderIcons.png", 3, Vec2f(16,32), tl+Vec2f(96,-16), 1.0f);
}

