// Knight brain

#define SERVER_ONLY

#include "/Entities/Common/Emotes/EmotesCommon.as"

namespace Strategy
{
enum strategy_type
{
    attacking = 0,
    defensive
}
}

void onInit( CBrain@ this )
{
    CBlob @blob = this.getBlob();
    blob.set_bool("justgo", false);
    blob.set_Vec2f("target spot", Vec2f_zero);
    blob.set_u8("strategy", Random(2));
	this.getCurrentScript().removeIfTag = "dead";   //won't be removed if not bot cause it isnt run
}

void onTick( CBrain@ this )
{
    CBlob @blob = this.getBlob();
    bool TESTING = false;

    if (this.getTarget() is null && (getGameTime() % 45) == 0) {
        FindNewTarget(this, blob);
    }

    if (this.getTarget() !is null)
    {
        // DEBUG: aim shield at me
        if (TESTING)
        {
            blob.setAimPos( this.getTarget().getPosition() );
            blob.setKeyPressed( key_action2, true );

            if ( (this.getTarget().getPosition() - blob.getPosition()).Length() > blob.getRadius() * 10.0f) {
                GoToBlob(this,  this.getTarget() );
            }

            //else
            //      blob.setKeyPressed( key_action2, true );
            /*if (this.getTarget().getPosition().x > blob.getPosition().x)
                this.getBlob().setKeyPressed( key_right, true );
            else
            if ( (this.getTarget().getPosition() - blob.getPosition()).Length() > blob.getRadius() * 6.0f)
            {
                this.getBlob().setKeyPressed( key_up, true );
                this.getBlob().setKeyPressed( key_left, true );
            }

            //if (!blob.isOnGround())
            blob.setKeyPressed( key_action2, true );
            blob.setAimPos( this.getTarget().getPosition() );    */
        }
        else
        {
            if ( (this.getTarget().getPosition() - blob.getPosition()).Length()  < blob.getRadius() * 20.0f) {
                AttackBlob(this,  this.getTarget() );
            }
            else {
                GoToBlob(this,  this.getTarget() );
            }
        }

        // lose target if its killed (with random cooldown)

        if (Random(20) == 0 && this.getTarget().hasTag("dead"))
        {
            this.SetTarget( null );
        }
    }
}

void FindNewTarget( CBrain@ this, CBlob @blob )
{
    CBlob@[] players;
    getBlobsByTag( "player", @players );

    for (uint i=0; i < players.length; i++)
    {
        CBlob@ potential = players[i];

        if (potential !is blob && blob.getTeamNum() != potential.getTeamNum() &&
                !potential.hasTag("dead"))
        {
            this.SetTarget( potential );
            this.getBlob().set_Vec2f("target spot", potential.getPosition() );
            return;
        }
    }
}

void Repath( CBrain@ this )
{
    this.SetPathTo( this.getTarget().getPosition(), false );
}

void GoToBlob( CBrain@ this, CBlob @target )
{
    CBlob @blob = this.getBlob();
    Vec2f targetVector = target.getPosition() - blob.getPosition();
    f32 targetDistance = targetVector.Length();
    // check if we have a clear area to the target
    bool justGo = false;

    if (targetDistance < 80.0f)
    {
        Vec2f col;

        if (!getMap().rayCastSolid( blob.getPosition(), target.getPosition(), col ))
        {
            justGo = true;
        }
    }

    // repath if no clear path after going at it
    if (!justGo && blob.get_bool("justgo"))
    {
        Repath( this );
    }
    else // occasionally repath when target is off of our spot
        if (Random(50) == 0 && (this.getBlob().get_Vec2f("target spot") - target.getPosition()).getLength() > 50.0f)
        {
            Repath( this );
        }

    //printf("targetDistance " + targetDistance );
    blob.set_bool("justgo", justGo);

    if (justGo)
    {
        JustGo( this, target.getPosition() );
        blob.set_u8("emote", Emotes::off);
    }
    else
    {
        // printInt("state", this.getState() );
        switch (this.getState())
        {
        case CBrain::idle:
            Repath( this );
            break;

        case CBrain::searching:
            set_emote( blob, Emotes::question );
            break;

        case CBrain::has_path:
            this.SetSuggestedKeys();  // set walk keys here
            break;

        case CBrain::stuck:
            Repath( this );
            break;

        case CBrain::wrong_path:
            Repath( this );
            break;
        }
    }

    // face the enemy
    blob.setAimPos( target.getPosition() );
    // jump over small blocks
    Vec2f pos = blob.getPosition();

    if ( (blob.isKeyPressed( key_right ) && getMap().isTileSolid( pos + Vec2f(1.3f*blob.getRadius(), blob.getRadius())*1.0f ) ) ||
            (blob.isKeyPressed( key_left ) && getMap().isTileSolid( pos + Vec2f(-1.3f*blob.getRadius(), blob.getRadius())*1.0f ) ) )
    {
        blob.setKeyPressed( key_up, true );
    }
}

bool JustGo( CBrain@ this, Vec2f point )
{
    CBlob @blob = this.getBlob();
    Vec2f mypos = blob.getPosition();
    f32 distance = (point - mypos).Length();

    if (distance > 32.0f * blob.getRadius())
    {
        if (point.x < mypos.x) {
            blob.setKeyPressed( key_left, true );
        }
        else {
            blob.setKeyPressed( key_right, true );
        }

        if (point.y + getMap().tilesize < mypos.y) {
            blob.setKeyPressed( key_up, true );
        }

        return true;
    }

    return false;
}

void AttackBlob( CBrain@ this, CBlob @target )
{
    CBlob @blob = this.getBlob();
    u8 strategy = blob.get_u8("strategy");
    Vec2f mypos = blob.getPosition();
    Vec2f targetPos = target.getPosition();
    Vec2f targetVector = targetPos - mypos;
    f32 targetDistance = targetVector.Length();

    if (targetDistance > blob.getRadius() + 24.0f)
    {
        if (strategy == Strategy::attacking) // attack
        {
            if (targetPos.x < mypos.x) {
                blob.setKeyPressed( key_left, true );
            }
            else {
                blob.setKeyPressed( key_right, true );
            }

            if (targetPos.y + getMap().tilesize < mypos.y) {
                blob.setKeyPressed( key_up, true );
            }
        }
        else // defensive - keep distance
        {
            if (targetPos.x < mypos.x) {
                blob.setKeyPressed( key_right, true );
            }
            else {
                blob.setKeyPressed( key_left, true );
            }

            if (targetDistance < blob.getRadius() + 8.0f) { // jump up avoid
                blob.setKeyPressed( key_up, true );
            }

            if (blob.isOnWall() && Random(2) == 0) {  // attack if cornered
                blob.set_u8("strategy", Strategy::attacking);
            }
        }
    }

    if (blob.isOnWall()) {
        blob.setKeyPressed( key_up, true );
    }

    // aim always at enemy
    blob.setAimPos( targetPos );

    if (target.isKeyPressed( key_action1 )) // enemy is attacking me
    {
        blob.set_u32( "shield time", getGameTime() );
    }
    else
    {
        // start attack
        if (Random(11) == 0)
        {
            blob.set_u32( "attack time", getGameTime() );
        }
    }

    if ( getGameTime() - blob.get_u32( "shield time") < uint(40+Random(20)) ) // hold shield for a while
    {
        blob.setKeyPressed( key_action2, true );
        /*if (blob.isOnGround())
            blob.setKeyPressed( key_up, true );
        if (targetPos.x < mypos.x) {
            blob.setKeyPressed( key_right, true );
        }
        else {
            blob.setKeyPressed( key_left, true );
        } */
    }
    else if ( targetDistance < 40.0f && getGameTime() - blob.get_u32( "attack time") < 10 ) // release and attack when appropriate
    {
        if (!target.isKeyPressed( key_action1 )) {
            blob.setKeyPressed( key_action2, false );
        }

        blob.setKeyPressed( key_action1, true );
    }

    // randomize strategy spontaneously

    if (Random(75) == 0)
    {
        if (blob.getHealth() < blob.getInitialHealth()) {
            blob.set_u8("strategy", Random(2));
        }
        else {
            blob.set_u8("strategy", Strategy::attacking);
        }
    }
}