//common knight header
namespace KnightStates
{
enum States {
    normal = 0,
    shielding,
    shieldbashingprep,
    shieldbashing,
    shielddropping,
    shieldgliding,
    sword_drawn,
    sword_cut_mid,
    sword_cut_mid_down,
    sword_cut_up,
    sword_cut_down,
    sword_power,
    sword_power_super
}
}

namespace KnightVars
{
const ::s32 resheath_time = 5;
const ::s32 chop_time = 2;

const ::s32 slash_charge = 20;
const ::s32 slash_charge_level2 = 60;
const ::s32 slash_charge_limit = 100;
const ::s32 slash_time = 13;
const ::s32 slash_move_time = 4;

const ::f32 slash_move_max_speed = 4.0f;
}

shared class KnightInfo
{
	u8 swordTimer;
	u8 shieldTimer;
	bool doubleslash;
	
	u8 state;
}

//checking state stuff

bool isShieldState(u8 state)
{
    return (state >= KnightStates::shielding && state <= KnightStates::shieldgliding);
}

bool isSpecialShieldState(u8 state)
{
    return (state > KnightStates::shielding && state <= KnightStates::shieldgliding);
}

bool isSwordState(u8 state)
{
    return (state >= KnightStates::sword_drawn && state <= KnightStates::sword_power_super);
}

bool inMiddleOfAttack(u8 state)
{
    return ((state > KnightStates::sword_drawn && state <= KnightStates::sword_power_super) || state == KnightStates::shieldbashing || state == KnightStates::shieldbashing);
}
