//knight HUD

#include "/Entities/Common/GUI/ActorHUDStartPos.as";

const string KNIGHT_ICON = "Entities/Characters/Knight/KnightIcons.png";

void onInit( CSprite@ this )
{
	this.getCurrentScript().runFlags |= Script::tick_myplayer;
	this.getCurrentScript().removeIfTag = "dead";
}
	   
void ManageCursors( CBlob@ this )
{
	if (getHUD().hasButtons()) {
		getHUD().SetDefaultCursor();
	}
	else
	{		 	
		if (this.isAttached() && this.isAttachedToPoint("GUNNER")) {
			getHUD().SetCursorImage("Entities/Characters/Archer/ArcherCursor.png", Vec2f(32,32));
			getHUD().SetCursorOffset( Vec2f(-32, -32) );
		}
		else {
			getHUD().SetCursorImage("Entities/Characters/Knight/KnightCursor.png", Vec2f(32,32));
		}
	}
}

void onRender( CSprite@ this )
{
	if (g_videorecording)
		return;

    CBlob@ blob = this.getBlob();

	ManageCursors( blob );

    blob.set_u8("gui_HUD_slots_width", 2);
    int num_bombs = blob.getBlobCount("mat_bombs");
    //render all relevant info into the bottom HUD rectangle:
    Vec2f tl = getActorHUDStartPosition(blob);
    GUI::DrawIcon( KNIGHT_ICON, 0, Vec2f(16,32), tl+Vec2f(32,-16), 1.0f);
    GUI::DrawText(""+num_bombs, tl +Vec2f(32,24), SColor(255,255,255,255));
    GUI::DrawIcon( KNIGHT_ICON, 1, Vec2f(16,32), tl+Vec2f(0,-16), 1.0f);
}

