
// Runner Ladder Movement

#include "RunnerCommon.as"

void onInit( CMovement@ this )
{
	this.getCurrentScript().removeIfTag = "dead";
	this.getCurrentScript().runFlags |= Script::tick_not_attached;
	this.getCurrentScript().runFlags |= Script::tick_not_onground;
	this.getCurrentScript().runFlags |= Script::tick_onladder;
}

void onTick( CMovement@ this )
{
    CBlob@ blob = this.getBlob();

    // ladder

    {
		RunnerMoveVars@ moveVars;
		if (!blob.get( "moveVars", @moveVars )) {
			return;
		}

        blob.getShape().SetGravityScale( 0.0f );
        Vec2f ladderforce;

        if (blob.isKeyPressed( key_up )) {
            ladderforce.y -= 1.0f;
        }

        if (blob.isKeyPressed( key_down )) {
            ladderforce.y += 1.0f;
        }
        
        if (blob.isKeyPressed( key_left )) {
            ladderforce.x -= 1.0f;
        }

        if (blob.isKeyPressed( key_right )) {
            ladderforce.x += 1.0f;
        }

        blob.AddForce(ladderforce * moveVars.overallScale * 100);
        //damp vel
        Vec2f vel = blob.getVelocity();
        vel.x *= 0.7;
        vel.y *= 0.7;
        blob.setVelocity( vel );
        
        moveVars.walkFactor = 0.0f;
        moveVars.jumpCount = -3;
    }
}
