// Runner Movement Stopping

#include "RunnerCommon.as"

void onInit( CMovement@ this )
{
	this.getCurrentScript().removeIfTag = "dead";
	this.getCurrentScript().runFlags |= Script::tick_not_attached;
	this.getCurrentScript().runFlags |= Script::tick_moving;
}

//set "no air drag" tag for what it says on the tin


void onTick( CMovement@ this )
{
    CBlob@ blob = this.getBlob();
	bool onGround = blob.isOnGround();     
    //stunned -> dont slow if in air
    if (!onGround)
    {
		if (blob.exists("knocked") && blob.get_u8("knocked") > 0)
			return;

		if (blob.hasTag("dont stop til ground"))
			return;
	}
	else
	{
		blob.Untag("dont stop til ground");
	}

	RunnerMoveVars@ moveVars;	 
	if (!blob.get( "moveVars", @moveVars )) {
		return;
	}

    bool left = blob.isKeyPressed(key_left);
    bool right = blob.isKeyPressed(key_right);
    bool jump = blob.isKeyPressed(key_up);
    
    Vec2f vel = blob.getVelocity();

	f32 x = vel.x;
	f32 abs_x = Maths::Abs(x);

	if (abs_x < 0.1f)
		return;
	
	Vec2f force;
	
	f32 sign_x = ((vel.x < 0.0f) ? -1.0f : 1.0f);

    if (!(left || right) ||
         (!left && vel.x < 0.0f) ||
         (!right && vel.x > 0.0f) )
    {
		force.x -= vel.x * 0.6f;
    }
    
    f32 targetvel = (onGround ? moveVars.walkSpeed : moveVars.walkSpeedInAir) * moveVars.walkFactor;
    
    if (abs_x > targetvel)
	{
		force.x -= sign_x;
	}

	if (force.LengthSquared() > 0.1f)
	{
		force *= (onGround ? moveVars.stoppingForce : moveVars.stoppingForceAir) * blob.getMass();
		blob.AddForce(force);
	}

	//anti-slope
    if ( vel.y > 0.1 && !( jump || left || right) && onGround && blob.getGroundNormal().y < 0.7f )
    {
        blob.AddForce(  vel * -moveVars.stoppingForce * 0.5f * blob.getMass() );
    }
}
