#include "RunnerCommon.as";

void onInit( CMovement@ this )
{
	this.getCurrentScript().removeIfTag = "dead";
	this.getCurrentScript().runFlags |= Script::tick_not_attached;
	this.getCurrentScript().runFlags |= Script::tick_inwater;
}

void onTick( CMovement@ this )
{
    CBlob@ blob = this.getBlob();
    //if (blob.isInWater()) // script opt
    {
		CMap@ map = getMap();
		RunnerMoveVars@ moveVars;
		if (!blob.get( "moveVars", @moveVars )) {
			return;
		}

		const f32 swimspeed = moveVars.swimspeed;
		const f32 swimforce = moveVars.swimforce;
		const f32 edgespeed = moveVars.swimspeed * moveVars.swimEdgeScale;
        Vec2f vel = blob.getVelocity();
											   
        if (!blob.isOnGround() && !blob.isOnLadder())
        {
            moveVars.walkFactor = 0.0f;
            moveVars.jumpFactor = 0.0f;
            moveVars.jumpCount = 50;
        }
        else
        {
            moveVars.walkFactor *= 0.2f;
            moveVars.jumpFactor *= 0.5f;
        }

        Vec2f pos = blob.getPosition();
        Vec2f waterForce;

        //up and down
        if (blob.isKeyPressed(key_up))
        {
            if (vel.y > -swimspeed)
            {
                if ( !map.isInWater( pos + Vec2f(0, -8) ) ) {
                    waterForce.y -= 0.6f;
                }
                else {
                    waterForce.y -= 0.8f;
                }
            }

            // more push near ledge
            if (vel.y > -(swimspeed * 2))
            {
                if (blob.isOnWall())
                {
                    if (blob.isOnMap()) {
                        waterForce.y -= 3.0f;
                    }
                    else {
                        waterForce.y -= 3.5f;
                    }
                }
            }
        }

        if (blob.isKeyPressed(key_down)
                && vel.y < swimspeed )
        {
            waterForce.y += 1;
        }

        //left and right
        if (blob.isKeyPressed(key_left)
                && vel.x > -swimspeed )
        {
            waterForce.x -= 1;
        }

        if (blob.isKeyPressed(key_right)
                && vel.x < swimspeed )
        {
            waterForce.x += 1;
        }

        waterForce *= swimforce * moveVars.overallScale;
        blob.AddForce(waterForce);
    }
}
