#include "RunnerCommon.as";

void onInit( CMovement@ this )
{
	this.getCurrentScript().removeIfTag = "dead";
	this.getCurrentScript().runFlags |= Script::tick_not_attached;
	this.getCurrentScript().runFlags |= Script::tick_not_inwater;
}

void onTick( CMovement@ this )
{
	CBlob@ blob = this.getBlob();
    if (blob.isKeyPressed(key_up))
    {			
		RunnerMoveVars@ moveVars;
		if (!blob.get( "moveVars", @moveVars )) {
			return;
		}
		if (!moveVars.canVault)
			return;

		CMap@ map = getMap();

        // boost over corner
        Vec2f pos = blob.getPosition();
        Vec2f groundNormal = blob.getGroundNormal();
        bool onMap = blob.isOnMap();
        bool canFreeVault = !onMap && moveVars.jumpCount < 5;
        bool left = blob.isKeyPressed(key_left);
        bool right = blob.isKeyPressed(key_right);
        groundNormal.Normalize();
        bool sidekeypressed = ( (left && (groundNormal.x > 0.1f || canFreeVault)) ||
                                (right && (groundNormal.x < -0.1f || canFreeVault) ) );

        if (sidekeypressed)
        {
			bool vault = false;

            if (left)
            {
                f32 movingside = -1.0f;

                if (canVault(blob, map, movingside))
                {
                    vault = true;
                }
            }

            if (right)
            {
                f32 movingside = 1.0f;

                if (canVault(blob, map, movingside))
                {
                    vault = true;
                }
            }

            if (vault)
            {
                moveVars.jumpCount = -3;
            }
        }
    }

    //moveVars.canVault = true; // script opt
}

const f32 offsetheight = -1.2f;
bool canVault(CBlob@ blob, CMap@ map, f32 movingside )
{
	Vec2f pos = blob.getPosition();
	
	f32 tilesize = map.tilesize;
    if (!map.isTileSolid( Vec2f( pos.x + movingside * tilesize, pos.y + tilesize*(offsetheight) ) ) &&
           !map.isTileSolid( Vec2f( pos.x + movingside * tilesize, pos.y + tilesize*(offsetheight+1) ) ) &&
           map.isTileSolid( Vec2f( pos.x + movingside * tilesize, pos.y + tilesize *(offsetheight+2) ) ))
    {
           
		bool hasRayFace = map.rayCastSolid(pos + Vec2f(0,-6), pos + Vec2f(movingside * 12,-6));
		bool hasRayFeet = map.rayCastSolid(pos + Vec2f(0,6), pos + Vec2f(movingside * 12,6));

		return (!hasRayFace && hasRayFeet);
	}
	return false;
}
