
//dynamic physics is a bit of crap when it comes to making fluid movement
//this helps pull us over corners and stick to walls we're pushing ourselves onto

#include "RunnerCommon.as";
#include "MakeDustParticle.as";

void onInit( CMovement@ this )
{
	this.getCurrentScript().removeIfTag = "dead";
	this.getCurrentScript().runFlags |= Script::tick_moving;
}

void onTick( CMovement@ this )
{
    CBlob@ blob = this.getBlob();
	Vec2f vel = blob.getVelocity();
	if (vel.y > 1.0f)
	{
		blob.Tag("walljumped");
	}

	if (blob.isOnGround())
	{
		blob.Untag("walljumped");
	}
    else if (!blob.isOnCeiling()  &&
		blob.isKeyJustPressed(key_up) && !blob.isOnLadder() )
    {
		RunnerMoveVars@ moveVars;
		if (!blob.get( "moveVars", @moveVars )) {
			return;
		}	  
		if (moveVars.jumpCount == 0)
			return;

		CMap@ map = blob.getMap();

		bool sliding = false;
		Vec2f pos = blob.getPosition();


        //get direction for walljump purposes
		//vel first
		f32 direction = (vel.x > 0.2f) ? 0.1f : ((vel.x < -0.2f) ? -1.0f : 0.0f);

		const bool right = blob.isKeyPressed(key_right);
		const bool left = blob.isKeyPressed(key_left);

		if (Maths::Abs(direction) <= 0.5f)
		{
			if (left)    { direction -= 1.0f; }	   
			if (right)   { direction += 1.0f; }
		}

		if (Maths::Abs(direction) <= 0.5f)
		{
			direction += (blob.isFacingLeft()) ? -1.0f : 1.0f ;
		}

		{
			Vec2f wall_front;
			Vec2f wall_back;
			
			const s32 offset = -2;
			const s32 x_dist = 12;
			
			bool hasRayDirection = map.rayCastSolid(pos + Vec2f(0,offset), pos + Vec2f(direction * x_dist,offset), wall_front);
			bool hasRayNOTDirection = map.rayCastSolid(pos+ Vec2f(0,offset), pos + Vec2f(direction * -x_dist,offset), wall_back);

			bool hasRayRight = direction > 0 ? hasRayDirection : hasRayNOTDirection;
			bool hasRayLeft = direction < 0 ? hasRayDirection : hasRayNOTDirection;

			if ( hasRayDirection || hasRayNOTDirection )
			{
				f32 front_dist = hasRayDirection ? Maths::Abs(pos.x - wall_front.x) : 1000.0f;
				f32 back_dist = hasRayNOTDirection ? Maths::Abs(pos.x - wall_back.x) : 1000.0f;
					
				f32 walljumpforce = 4.0f;
				f32 jumpAngle = -20;
				if ( !((left && hasRayRight) || (right && hasRayLeft)) &&
					 !blob.hasTag("walljumped") )
				{
					jumpAngle = -50;
					blob.Tag("walljumped");
				}
				
				Vec2f newvel(walljumpforce, 0);
				newvel = newvel.RotateBy(jumpAngle, Vec2f());
				
				newvel.x *= direction;
				if (front_dist < back_dist)
				{
					newvel.x *= -1;
				}
				if (!(left || right)) newvel.x *= 0.7f;
				
				blob.setVelocity(newvel);
				
				Vec2f dust_pos = (((front_dist > back_dist) ? wall_back : wall_front) + pos) * 0.5f;
				MakeDustParticle(dust_pos, "Smoke.png");
				
				moveVars.jumpCount = 0;
			}
		}
	}
}
