//dynamic physics is a bit of crap when it comes to making fluid movement
//this helps pull us over corners and stick to walls we're pushing ourselves onto

#include "RunnerCommon.as";
#include "MakeDustParticle.as";

void onInit( CMovement@ this )
{
	this.getCurrentScript().removeIfTag = "dead";
	this.getCurrentScript().runFlags |= Script::tick_not_inwater;
	this.getCurrentScript().runFlags |= Script::tick_not_onladder;
	this.getCurrentScript().runFlags |= Script::tick_not_onground;
	this.getCurrentScript().runFlags |= Script::tick_onmap;
}

void onTick( CMovement@ this )
{
    CBlob@ blob = this.getBlob();

    //if (blob.isInWater())
    //{
    //  //  blob.Untag("wallsliding"); RunnerDefault.as;
    //    return;
    //}

    if ( !blob.isOnCeiling() &&
            !blob.isKeyPressed(key_down) )
    {
		CMap@ map = blob.getMap();
		RunnerMoveVars@ moveVars;	 
		if (!blob.get( "moveVars", @moveVars )) {
			return;
		}

		Vec2f groundNormal = blob.getGroundNormal();
        Vec2f pos = blob.getPosition();
        Vec2f vel = blob.getVelocity();
        //now check in front of my face
        const f32 ts = map.tilesize;
        const f32 y_ts = ts * 0.2f;
        const f32 x_ts = ts * 1.4f;
        bool surface = map.isTileSolid(pos + Vec2f(x_ts, y_ts)) || map.isTileSolid(pos + Vec2f(-x_ts, y_ts));

        if (surface) //we dont have open air on either side of our upper body
        {
            if (
				(blob.isKeyPressed(key_left) || blob.isKeyPressed(key_right)) && // require direction key hold
				Maths::Abs(groundNormal.y) <= 0.01f) //sliding on wall
            {
                Vec2f force;
                const f32 slidespeed = 2.45f;

                if (vel.y >= slidespeed && ( blob.isFacingLeft() ? groundNormal.x > 0 : groundNormal.x < 0 ))
                {
                    f32 temp = vel.y * 0.9f;
                    Vec2f new_vel = Vec2f(vel.x * 0.9f, temp < slidespeed ? slidespeed : temp);
                    blob.setVelocity(new_vel);

                    if (!blob.hasTag("wallsliding")) {
                        blob.getSprite().PlaySound( "/Scrape" );
                    }

                    //falling for almost a second so add effects
                    if (moveVars.jumpCount > 20)
                    {
                        int gametime = getGameTime();

                        if (gametime % (uint(Maths::Max(0,7-int(Maths::Abs(vel.y))))+3) == 0)
                        {
                            MakeDustParticle(pos, "/dust2.png");
                            blob.getSprite().PlaySound( "/Scrape" );
                        }
                    }

                    blob.Tag("wallsliding");
                }
            }
        }
    }
}

