
const string knocked_tag = "knockable";

//make sure to use this in onInit if needed

void setKnockable( CBlob@ this )
{
	this.set_u8("knocked", 0);
	this.Tag(knocked_tag);
}

u8 Knocked( CBlob@ this )
{
    u8 knocked = this.get_u8("knocked");

    if (knocked > 0)
    {
        knocked--;
        this.set_u8("knocked", knocked);
        this.DisableKeys( key_left | key_right | key_up | key_down | key_action1 | key_action2 | key_action3 );
        this.DisableMouse(true);
    }
    else
    {
        this.DisableKeys(0);
        this.DisableMouse(false);
    }
	return knocked;
}

bool isKnockable( CBlob@ blob )
{
	return blob.hasTag(knocked_tag);
}

void SetKnocked( CBlob@ blob, int ticks, bool sync = false )
{
    blob.set_u8("knocked", Maths::Max( blob.get_u8("knocked"), ticks));
	if (sync)
	{			
		blob.Sync("knocked", true );
	}
}
