
//drowning for all characters

#include "/Entities/Common/Attacks/Hitters.as"

//config vars

const int FREQ = 10;
const s8 default_aircount = 80;

void onInit( CBlob@ this )
{
    this.set_s8("air_count", default_aircount);
    this.set_u8("drown_timer", 2);
	this.getCurrentScript().removeIfTag = "dead";
	this.getCurrentScript().tickFrequency = sv_test ? 0 : FREQ; // opt
}

void onTick( CBlob@ this )
{
    const bool inwater = this.isInWater();
    
    s8 aircount = this.get_s8("air_count");
    u8 drown_timer = this.get_u8("drown_timer");

    if (inwater)
    {
        if (aircount > -100) {
            aircount-=FREQ;
        }
		        
        //drown damage
		if (aircount < -30)
		{
			if (drown_timer == 0)
				drown_timer = 2;
			drown_timer++;		
			if (drown_timer == 7)
			{
				this.server_Hit( this, this.getPosition(), Vec2f(0,0), 0.5f, Hitters::drown, true );
				Sound::Play( CFileMatcher("Gurgle").getRandom(), this.getPosition(), 2.0f );
				drown_timer = 3;
			}
		}
    }
    else
    {
		if (drown_timer > 0)
		{
			drown_timer--;
		}
        else if (aircount < default_aircount)
        {
			drown_timer = 0;
			
			if (aircount == 0) {
				Sound::Play( "Sounds/gasp.ogg", this.getPosition(), 3.0f );
			}

            aircount+=FREQ;
        }
    }

	//printf("aircount " + aircount );

	this.set_u8("drown_timer", drown_timer);
	this.set_s8("air_count", aircount);
}

void onRender(CSprite@ this)
{
	CBlob@ blob = this.getBlob();
	if(!blob.isMyPlayer()) return;
	
    s8 aircount = blob.get_s8("air_count");
	
	if (aircount < 30)
    {
        SetScreenFlash( -(aircount - 30) * 1.0, 12, 0, 30 );
    }
}
