// Draw an emoticon

#include "EmotesCommon.as";

void onInit( CSprite@ this )
{
    CBlob@ blob = this.getBlob();
    blob.set_u8("emote", Emotes::off);
    blob.set_u32("emotetime", 0);
    //init flame layer
    CSpriteLayer@ emote = this.addSpriteLayer( "bubble", "Entities/Common/Emotes/Emoticons.png", 32, 32, -1, -1 );

    if (emote !is null)
    {
        emote.SetOffset(Vec2f(0,-this.getBlob().getRadius()*2.0f-16));
        emote.SetRelativeZ(100.0f);
        {
            Animation@ anim = emote.addAnimation( "default", 0, true );

            for (int i = 0; i < Emotes::emotes_total; i++) {
                anim.AddFrame(i);
            }
        }
        emote.SetVisible( false );
        emote.SetHUD( true );
    }

    AddBubblesToMenu( this.getBlob() );
}



void onTick( CSprite@ this )
{
    CBlob@ blob = this.getBlob();

    if (blob.exists("emote"))
    {
        CSpriteLayer@ emote = this.getSpriteLayer( "bubble");

        if (emote !is null)
        {
            u8 index = blob.get_u8("emote");
            u32 time = blob.get_u32("emotetime") + 90;

            if (time > getGameTime() && index != Emotes::off)
            {
                emote.SetVisible( true );
                emote.animation.frame = index;
                emote.ResetTransform();

                if (this.isFacingLeft()) {
                    emote.ScaleBy(Vec2f(-1.0f,1.0f));
                }
            }
            else
            {
                emote.SetVisible( false );
            }
        }
    }
}

void AddBubblesToMenu( CBlob@ this )
{
    this.LoadBubbles( "GUI/Emoticons.png" );

    for (int i = Emotes::skull; i < Emotes::cog; i++) {
        if (i != Emotes::pickup && i != Emotes::blank && i != Emotes::dots) {
            this.AddBubble( "", i );
        }
    }
}