// Draw a flame sprite layer

#include "FireParticle.as";
#include "FireCommon.as";

void onInit( CSprite@ this )
{
    //init flame layer
    CSpriteLayer@ fire = this.addSpriteLayer( "fire_animation_large", "Entities/Effects/Sprites/LargeFire.png", 16, 16, -1, -1 );

    if (fire !is null)
    {
        {
            Animation@ anim = fire.addAnimation( "bigfire", 3, true );
            anim.AddFrame(1);
            anim.AddFrame(2);
            anim.AddFrame(3);
        }
        {
            Animation@ anim = fire.addAnimation( "smallfire", 3, true );
            anim.AddFrame(4);
            anim.AddFrame(5);
            anim.AddFrame(6);
        }
        fire.SetVisible( false );
    }

	this.getCurrentScript().tickFrequency = 16; // opt
}

void onTick( CSprite@ this )
{
    //check if we even have the fire properties vars
    CBlob@ blob = this.getBlob();
    CSpriteLayer@ fire = this.getSpriteLayer( "fire_animation_large");	   
	if (fire !is null)
	{
		const s16 burn_time = blob.get_s16( burn_timer );

		//if we're burning
		if (burn_time > 0)
		{
			fire.SetVisible( true );

			//draw the fire layer with varying sizes based on var
			if (burn_time > 70) {
				fire.SetAnimation( "bigfire" );
			}
			else {
				fire.SetAnimation( "smallfire" );
			}

			//drop some fire and smoke particles
			if ((getGameTime() + blob.getNetworkID()) % 4 == 0 )
			{
				makeFireParticle(blob.getPosition() + Vec2f(Random(16)-8,Random(16)-8));
			}

			//set the on fire animation if it exists
			if (this.isAnimationEnded())
			{
				if (this.getAnimation("on_fire") !is null) {
					this.SetAnimation("on_fire");
				}
			}
		}
		else
		{
			fire.SetVisible( false );
		}
	}
}
