string getButtonRequirementsText( CBitStream& inout bs, bool missing )
{
    string text, requiredType, name, friendlyName;
    u16 quantity = 0;
    bs.ResetBitIndex();

    while (!bs.isBufferEnd())
    {
        ReadRequirement( bs, requiredType, name, friendlyName, quantity );
        string quantityColor;

        if (missing) {
            quantityColor = "$RED$";
        }
        else {
            quantityColor = "$GREEN$";
        }

        if (requiredType == "blob")
        {
			if (quantity > 0)
			{
				text += quantityColor;
				text += quantity;
				text += quantityColor;
				text += " ";
			}
            text += "$"; text += name; text += "$";
            text += " ";
            text += quantityColor;
            text += friendlyName;
            text += quantityColor;
           // text += " required.";
			 text += "\n";
        }
        else if (requiredType == "tech")
        {
            text += " $"; text += name; text += "$ ";
            text += quantityColor;
            text += friendlyName;
            text += quantityColor;
            text += " technology required.\n";
        }
        else if (requiredType == "coin")
        {
            text += quantity;
            text += " $coin$ required\n";
        }
        else if (requiredType == "shop")
        {
        }
        else if (requiredType == "time")
        {
            text += "$TIME$ ";
            text += friendlyName;
            text += " ";
            text += quantityColor;
            text += quantity;
            text += quantityColor;
            text += "\n";
        }
    }

    return text;
}

void SetItemDescription( CGridButton@ button, CBlob@ caller, CBitStream& in reqs, const string& in description, CInventory@ anotherInventory = null )
{
    if (button !is null && caller !is null && caller.getInventory() !is null)
    {
        CBitStream missing;

        if (hasRequirements( caller.getInventory(), anotherInventory, reqs, missing )) {
            button.hoverText = description + "\n\n " + getButtonRequirementsText( reqs, false );
        }
        else
        {
            button.hoverText = description + "\n\n " + getButtonRequirementsText( missing, true );
            button.SetEnabled( false );
        }
    }
}		  