// REQUIRES:
//
//      onRespawnCommand() to be called in onCommand()
//
//  implementation of:
//
//      bool canChangeClass( CBlob@ this, CBlob @caller )
//
// Tag: "change class sack inventory" - if you want players to have previous items stored in sack on class change
// Tag: "change class store inventory" - if you want players to store previous items in this respawn blob

#include "/Entities/Common/Respawning/ClassSelectMenu.as"

void BuildRespawnMenuFor( CBlob@ this, CBlob @caller )
{
	PlayerClass[]@ classes;
    this.get( "playerclasses", @classes );

    if (caller !is null && caller.isMyPlayer() && classes !is null)
    {
        CGridMenu@ menu = CreateGridMenu( caller.getScreenPos() + Vec2f(24.0f, caller.getRadius() * 1.0f), this, Vec2f(classes.length*CLASS_BUTTON_SIZE,CLASS_BUTTON_SIZE), "Swap class" );
        if (menu !is null) {
            addClassesToMenu(this, menu, caller.getNetworkID());
        }
    }
}

void onRespawnCommand( CBlob@ this, u8 cmd, CBitStream @params )
{
	// ESP SOMEHING CRASH
//	const uint64 index = params.getBitIndex(); // save index so other functons don't freak out 
	// DO NOT RETURN IN ANYWHERE BUT THE END !

	switch( cmd )
    {
    case SpawnCmd::buildMenu:
    {
        {
            // build menu for them
            CBlob@ caller = getBlobByNetworkID( params.read_u16() );
            BuildRespawnMenuFor( this, caller );
        }
    }
    break;

    case SpawnCmd::changeClass:
    {
        if (getNet().isServer() )
        {
            // build menu for them
            CBlob@ caller = getBlobByNetworkID( params.read_u16() );

            if (caller !is null && canChangeClass( this, caller ))
            {
                string classconfig = params.read_string();
                CBlob @newBlob = server_CreateBlob( classconfig, caller.getTeamNum(), this.getRespawnPosition() );

                if (newBlob !is null)
                {
                    // copy health and inventory
                    // make sack
                    CInventory @inv = caller.getInventory();

                    if (inv !is null)
                    {
						if (this.hasTag("change class store inventory"))
						{		
							if (this.getInventory() !is null) {
								caller.MoveInventoryTo( this );
							}
							else // find a storage
							{	   
								PutInvInStorage( caller );
							}
						}
						else
                        if (this.hasTag("change class sack inventory"))
                        {
                            // only make sack if there are more than 1 things in inv
                            if (inv.getItemsCount() > 1)
                            {
                                CBlob@ sack = server_CreateBlob( "sack", caller.getTeamNum(), caller.getPosition() );
                                caller.MoveInventoryTo( sack );
                            }
                            else {
                                caller.MoveInventoryTo( newBlob );
                            }
                        }
                        else
                        {
                            // destroy inventory
                            while (inv.getItemsCount() > 0)
                            {
                                CBlob @item = inv.getItem(0);
                                caller.server_PutOutInventory( item );
                                item.server_Die();
                            }
                        }
                    }

                    newBlob.server_SetHealth( caller.getHealth() );   // TODO: ISSUE, ARCHER WILL HAVE MORE HEARTS IF CHANGED FROM KNIGHT
                    // plug the soul
                    newBlob.server_SetPlayer( caller.getPlayer() );
                    newBlob.setPosition( caller.getPosition() );
                    caller.Tag("switch class");
                    caller.server_SetPlayer( null );
                    caller.server_Die();
                }
            }
        }
    }
    break;
    }

	//params.SetBitIndex( index );
}

void PutInvInStorage( CBlob@ blob )
{
	CBlob@[] storages;
	if (getBlobsByName( "storage", @storages ))
		for (uint step = 0; step < storages.length; ++step)
		{
			CBlob@ storage = storages[step];
			if (storage.getTeamNum() == blob.getTeamNum())
			{																
				blob.MoveInventoryTo( storage );
				return;
			}
		}
}