// Standard menu player controls

#include "ThrowCommon.as"
#include "EmotesCommon.as"

int zoomLevel = 1; // we can declare a global because this script is just used by myPlayer

void onInit( CBlob@ this )
{
    this.set_s32( "tap_time", getGameTime() );
    CBlob@[] blobs;
    this.set( "pickup blobs", blobs );
    this.set_u16("hover netid", 0);
    this.set_bool("release click", false);
    this.set_bool("can button tap", true);
    this.addCommandID("pickup");
    this.addCommandID("putin");
    this.addCommandID("detach");
    this.addCommandID("getout");

	this.getCurrentScript().runFlags |= Script::tick_myplayer;
	this.getCurrentScript().removeIfTag = "dead";
}

void server_Pickup( CBlob@ this, CBlob@ picker, CBlob@ pickBlob )
{
    CBitStream params;
    params.write_netid( picker.getNetworkID() );
    params.write_netid( pickBlob.getNetworkID() );
    this.SendCommand( this.getCommandID("pickup"), params );
}

void server_PutIn( CBlob@ this, CBlob@ picker, CBlob@ pickBlob )
{
    CBitStream params;
    params.write_netid( picker.getNetworkID() );
    params.write_netid( pickBlob.getNetworkID() );
    this.SendCommand( this.getCommandID("putin"), params );
}

void onCommand( CBlob@ this, u8 cmd, CBitStream @params )
{
    if (!getNet().isServer()) {                              // server only!
        return;
    }

    if (cmd == this.getCommandID("putin"))
    {
        CBlob@ owner = getBlobByNetworkID( params.read_netid() );
        CBlob@ pick = getBlobByNetworkID( params.read_netid() );

        if (owner !is null && pick !is null)
        {
            if (!owner.server_PutInInventory( pick ))
				owner.server_Pickup( pick );
        }
    } else if (cmd == this.getCommandID("pickup"))
    {
        CBlob@ owner = getBlobByNetworkID( params.read_netid() );
        CBlob@ pick = getBlobByNetworkID( params.read_netid() );

        if (owner !is null && pick !is null)
        {
            owner.server_Pickup( pick );
        }
    } else if (cmd == this.getCommandID("detach"))
    {
        CBlob@ obj = getBlobByNetworkID( params.read_netid() );

        if (obj !is null)
        {
            this.server_DetachFrom( obj );
        }
    } else if (cmd == this.getCommandID("getout"))
    {
        if (this.getInventoryBlob() !is null)
        {
            this.getInventoryBlob().server_PutOutInventory( this );
        }
    }
}

bool ClickGridMenu( CBlob@ this, int button )
{
    CGridMenu @gmenu;
    CGridButton @gbutton;
    CBlob @pickBlob = this.getCarriedBlob();

    if (this.ClickGridMenu(button, gmenu, gbutton))   // button gets pressed here - thing get picked up
    {
        if (gmenu !is null)
        {
            // if (gmenu.getName() == this.getInventory().getMenuName() && gmenu.getOwner() !is null)
            {
                if (pickBlob !is null && gbutton is null)    // carrying something, put it in
                {
                    server_PutIn( this, gmenu.getOwner(), pickBlob );
                }
                else // take something
                {
                    // handled by button cmd   // hardcoded still :/
                }
            }
            return true;
        }
    }

    return false;
}


void ButtonOrMenuClick( CBlob@ this, Vec2f pos, bool clear, bool doClosestClick )
{
    if (!ClickGridMenu( this, 0 ))
        if (this.ClickInteractButton()) {
            clear = false;
        }
        else if (doClosestClick) {
            if (this.ClickClosestInteractButton( pos, this.getRadius() * 1.0f ))
            {
                this.ClearButtons();
                clear = false;
            }
        }

    if (clear)
    {
        this.ClearButtons();
        this.ClearMenus();
    }
}

void Tap( CBlob@ this )
{
    this.set_s32( "tap_time", getGameTime() );
}


bool isTap( CBlob@ this )
{
    return (getGameTime() - this.get_s32( "tap_time" ) < 15);
}

void onTick( CBlob@ this )
{
    if (getCamera() is null) {
        return;
    }				  
    ManageCamera( this );

    // use menu

    if (this.isKeyJustPressed(key_use))
    {
        Tap( this );
        this.set_bool("can button tap", !getHUD().hasMenus() );
        this.ClearMenus();
        this.ShowInteractButtons();
        this.set_bool("release click", true);
    }
    else if (this.isKeyJustReleased(key_use))
    {
        if (this.get_bool("release click")) {
            ButtonOrMenuClick( this, this.getPosition(), true, isTap( this ) && this.get_bool("can button tap") );
        }

        this.ClearButtons();
    }

    CBlob @carryBlob = this.getCarriedBlob();

    // inventory menu

    if (this.getInventory() !is null)
    {
        if (this.isKeyJustPressed(key_inventory))
        {
            Tap( this );
            this.set_bool("release click", true);
            this.ClearMenus();

		//	Vec2f center =  getDriver().getScreenCenterPos(); // center of screen
			Vec2f center = getControls().getMouseScreenPos();
            if (this.exists("inventory offset"))
            {
                this.CreateInventoryMenu( center + this.get_Vec2f("inventory offset") );
            }
            else {
                this.CreateInventoryMenu( center );
            }

			//getControls().setMousePosition( center );
        }
        else if (this.isKeyJustReleased(key_inventory))
        {
            if (isTap( this ))   // tap - put thing in inventory
            {
                if (carryBlob !is null)
                {
                    server_PutIn( this, this, carryBlob );
                }

                this.ClearMenus();
                return;
            }
            else // click inventory
            {
                if (this.get_bool("release click")) {
                    ClickGridMenu( this, 0 );
                }

                this.ClearMenus();
            }
        }
    }

    // in crate

    if (this.isInInventory())
    {
        if (this.isKeyJustPressed(key_pickup))
        {
            this.SendCommand( this.getCommandID("getout") );
        }

        return;
    }

    // no more stuff possible while in crate...

    // drop / pickup / throw
    if (this.isKeyJustPressed(key_pickup))
    {
		/*if (isTap( this ))	tap pickup
		{
		CBlob@ carry = this.getCarriedBlob();
		if (carry !is null)
		{
		server_PutIn( this, this, carry );
		}
		}
		else*/
        if (this.isAttached()) // default drop from attachment
        {
            int count = this.getAttachmentPointCount();

            for (int i = 0; i < count; i++)
            {
                AttachmentPoint @ap = this.getAttachmentPoint(i);

                if (ap.getOccupied() !is null)
                {
                    CBitStream params;
                    params.write_netid( ap.getOccupied().getNetworkID() );
                    this.SendCommand( this.getCommandID("detach"), params );
                    break;
                }
            }
        }
        else if (carryBlob !is null && !carryBlob.hasTag("custom drop") && (!carryBlob.hasTag("temp blob") || carryBlob.getName() == "ladder"))
        {
            ClearPickupBlobs( this );
            client_SendThrowCommand( this );
            this.set_bool("release click", false);

        }
        else
        {
			Tap( this );
            this.set_bool("release click", true);
        }				
    }
    else
    {
        if (this.isKeyPressed(key_pickup))
        {
            GatherPickupBlobs( this );

            if (this.isKeyJustPressed(key_action1))	// pickup
            {
                ClickPickupBlobs( this );
                this.set_bool("release click", false);
            }
        }

        if (this.isKeyJustReleased(key_pickup))
        {
            if (isTap( this ))
            {
                PickupClosestBlob( this );
            }
            else if (this.get_bool("release click"))
            {
                ClickPickupBlobs( this );
            }

            ClearPickupBlobs( this );
        }
    }

    // bubble menu

    if (this.isKeyJustPressed(key_bubbles))
    {
        this.CreateBubbleMenu();
        Tap( this );
    }

    /*else dont use this cause menu won't be release/clickable
    if (this.isKeyJustReleased(key_bubbles))
    {
        this.ClearBubbleMenu();
    } */

    // release action1 to click buttons

    if (getHUD().hasButtons())
    {
        if ((this.isKeyJustPressed(key_action1) || getControls().isKeyJustPressed(KEY_LBUTTON)) && !this.isKeyPressed(key_pickup))
        {
            ButtonOrMenuClick( this, this.getAimPos(), false, true );
            this.set_bool("release click", false );
        }
    }

    // clear grid menus on move

    if (!this.isKeyPressed(key_inventory) && 
		(this.isKeyJustPressed(key_left) || this.isKeyJustPressed(key_right) || this.isKeyJustPressed(key_up) ||
            this.isKeyJustPressed(key_down) || this.isKeyJustPressed(key_action2) || this.isKeyJustPressed(key_action3))
			) {
        this.ClearMenus();
    }
}

// show dots on chat

void onEnterChat( CBlob @this )
{
    set_emote( this, Emotes::dots, 100000 );
}

void onExitChat( CBlob @this )
{
    set_emote( this, Emotes::off );
}

void onDie( CBlob@ this )
{
	set_emote( this, Emotes::off );
}

// CAMERA

void ManageCamera( CBlob@ this )
{
	CCamera@ camera = getCamera();
	f32 zoom = camera.targetDistance;

	// mouse look & zoom
    if ((getGameTime() - this.get_s32( "tap_time" ) > 5))
    {
        if (this.isKeyJustPressed(key_zoomout))
        {
            if (zoomLevel == 2) {
                zoomLevel = 1;
            }
            else if (zoomLevel == 1) {
                zoomLevel = 0;
            }
            else if (zoomLevel == 3) {
                zoomLevel = 0;
            }

            Tap( this );
        }
        else if (this.isKeyJustPressed(key_zoomin))
        {
            if (zoomLevel == 0) {
                zoomLevel = 3;
            }
            else if (zoomLevel == 3) {
                zoomLevel = 2;
            }
            else if (zoomLevel == 1) {
                zoomLevel = 2;
            }

            Tap( this );
        }
    }

    f32 zoomSpeed = 0.1f;
    f32 minZoom = 0.5f; // TODO: make vars
    f32 maxZoom = 2.0f;

	if ( zoomLevel == 1 && (this.wasKeyPressed(key_use) || this.wasKeyPressed(key_pickup)) )
	{
		zoom = 1.0f;
	}

	switch (zoomLevel)
	{
	case 0:
		if (zoom > 0.5f) {
			zoom -= zoomSpeed;
		}

		break;

	case 1:
		if (zoom > 1.0f) {
			zoom -= zoomSpeed;
		}
		else {
			zoom = 1.0f;
		}

		break;

	case 2:
		if (zoom < maxZoom) {
			zoom += zoomSpeed;
		}

		break;

	case 3:
		if (zoom < 1.0f) {
			zoom += zoomSpeed;
		}
		else {
			zoom = 1.0f;
		}

		break;

	default:
		zoom = 1.0f;
		break;
	}

    // security check

    if (zoom < minZoom) {
        zoom = minZoom;
    }

    if (zoom > maxZoom) {
        zoom = maxZoom;
    }


	bool fixedCursor = true;
	if (zoom < 1.0f)  // zoomed out
	{ 
		camera.mousecamstyle = 2; // fixed
	}
	else
	{  
		// gunner
		if (this.isAttachedToPoint("GUNNER"))
		{
			camera.mousecamstyle = 1;
		}
		else if (g_fixedcamera) // option
		{
			Vec2f vector = (getControls().getMouseScreenPos() - getDriver().getScreenCenterPos());
			int changelen = getDriver().getScreenWidthRatio() * (camera.mousecamstyle == 1 ? 255 : 458);
			fixedCursor = !((Maths::Abs(vector.x) > changelen) || (Maths::Abs(vector.y)*1.25f > changelen));

			if (!fixedCursor) {
				camera.mousecamstyle = 1;    // soldat
			}
			else {
				camera.mousecamstyle = 2;  // fixed
			}
		}
		else {
			camera.mousecamstyle = 1; // soldat
		}
	}

    // camera
    camera.mouseFactor = 0.5f; // doesn't affect soldat cam
    camera.targetDistance = zoom;
}

// PICKUP


void GatherPickupBlobs( CBlob@ this )
{
    CBlob@[]@ pickupBlobs;
    this.get("pickup blobs", @pickupBlobs );
    pickupBlobs.clear();
    CBlob@[] blobsInRadius;

    if (this.getMap().getBlobsInRadius( this.getPosition(), this.getRadius() + 320.0f, @blobsInRadius ))
    {
        for (uint i = 0; i < blobsInRadius.length; i++)
        {
            CBlob @b = blobsInRadius[i];

            if (b.canBePickedUp( this )) {
                pickupBlobs.push_back( b );
            }
        }
    }
}

void ClearPickupBlobs( CBlob@ this )
{
    this.clear("pickup blobs" );
}

bool ClickPickupBlobs( CBlob@ this )
{
    CBlob@[]@ pickupBlobs;

    if (this.get("pickup blobs", @pickupBlobs ))
    {
        for (uint i = 0; i < pickupBlobs.length; i++)
        {
            CBlob @b = pickupBlobs[i];

            if ( b.isPointInside( this.getAimPos() ) && canBlobBePickedUp( this, b ) )
            {
				server_Pickup( this, this, b );
                return true;
            }
        }
    }
	return false;
}

void PickupClosestBlob( CBlob@ this )
{
    // TODO: sort by size
    CBlob@[]@ pickupBlobs;	   
    if (this.get("pickup blobs", @pickupBlobs ))
    {
        Vec2f pos = this.getPosition();
        bool facingLeft = this.isFacingLeft();

        CBlob@[] available;	 
        for (uint i = 0; i < pickupBlobs.length; i++)
        {
            CBlob @b = pickupBlobs[i];

            if ( canBlobBePickedUp( this, b ) ) {
                available.push_back(b);
            }
        }

		// priority pickup - exploding kegs!

		for (uint i = 0; i < available.size(); i++)
		{ 	
			 CBlob @b = available[i];
			 const Vec2f bpos = b.getPosition();		 
			 if ( ( ( facingLeft && bpos.x < pos.x ) || ( !facingLeft && bpos.x >= pos.x ) ) &&
				  b.hasTag("exploding") )
			 {
				 server_Pickup( this, this, b );
				 return;
			 }
		}

		// sort by closest

        CBlob@[] closest;
		while (available.size() > 0)
        {
            f32 closestDist = 999999.9f;
            uint closestIndex = 999;

            for (uint i = 0; i < available.length; i++)
            {
                CBlob @b = available[i];
                Vec2f bpos = b.getPosition();
                f32 dist = (bpos - pos).getLength();

                if (dist < closestDist)
                {
                    closestDist = dist;
                    closestIndex = i;
                }
            }

            if (closestIndex >= 999) {
                break;
            }

            closest.push_back( available[closestIndex] );
            available.erase(closestIndex);
        }

        // try to pick closest as facing - smaller than me

        for (uint i = 0; i < closest.length; i++)
        {
            CBlob @b = closest[i];
            const Vec2f bpos = b.getPosition();

            if ( ( facingLeft && bpos.x < pos.x ) || ( !facingLeft && bpos.x >= pos.x ) &&
                    b.getRadius() < this.getRadius() )
            {
                server_Pickup( this, this, b );
                return;
            }
        }

        // try to pick closest as facing

        for (uint i = 0; i < closest.length; i++)
        {
            CBlob @b = closest[i];
            const Vec2f bpos = b.getPosition();		 
            if ( ( facingLeft && bpos.x < pos.x ) || ( !facingLeft && bpos.x >= pos.x ) )
            {
                server_Pickup( this, this, b );
                return;
            }
        }

        // if failed, just pick closest

        for (uint i = 0; i < closest.length; i++)
        {
            CBlob @b = closest[i];
            server_Pickup( this, this, b );
            return;
        }
    }
}

bool canBlobBePickedUp( CBlob@ this, CBlob@ blob )
{
    Vec2f pos = this.getPosition() + Vec2f(0.0f, -this.getRadius()*0.9f);
    Vec2f pos2 = blob.getPosition();
    return ( ((pos2 - pos).getLength() < (this.getRadius() + blob.getRadius())*1.5f + 18.0f) &&
             !blob.isAttached() &&
             !this.getMap().rayCastSolid( pos, pos2 )
           );
}

void onInit( CSprite@ this )
{
	this.getCurrentScript().runFlags |= Script::tick_myplayer;
}

void onRender( CSprite@ this )
{
    CBlob@ blob = this.getBlob();

    // render item held when in inventory

    if (blob.isKeyPressed( key_inventory ))
    {
        CBlob @pickBlob = blob.getCarriedBlob();

        if (pickBlob !is null)
        {
            pickBlob.RenderForHUD( (blob.getAimPos() + Vec2f(0.0f, 8.0f )) - blob.getPosition() , RenderStyle::normal );
        }
    }

	if (blob.isKeyPressed( key_pickup ))
	{
	   	// pickup render
		bool tickPlayed = false;
		bool hover = false;
		CBlob@[]@ pickupBlobs;

		if (blob.get("pickup blobs", @pickupBlobs ))
		{
			// render outline only if hovering
			for (uint i = 0; i < pickupBlobs.length; i++)
			{
				CBlob @b = pickupBlobs[i];

				bool canBePicked = canBlobBePickedUp( blob, b );

				if (canBePicked)
				{
					b.RenderForHUD( RenderStyle::outline_front );
				}

				if ( b.isPointInside( blob.getAimPos() ) )
				{
					hover = true;
					GUI::DrawText( b.getInventoryName(), b.getScreenPos() + Vec2f(-b.getWidth(), b.getHeight() + 16.0f), color_white );

					// draw mouse hover effect
					if (canBePicked)
					{
						b.RenderForHUD( RenderStyle::outline );

						if (!tickPlayed)
						{
							if (blob.get_u16("hover netid") != b.getNetworkID()) {
								Sound::Play( CFileMatcher("/select.ogg").getFirst() );
							}

							blob.set_u16("hover netid", b.getNetworkID());
							tickPlayed = true;
						}

						break;
					}
				}

			}

			// no hover
			if (!hover) {
				blob.set_u16("hover netid", 0);
			}

			// render outlines

			//for (uint i = 0; i < pickupBlobs.length; i++)
			//{
			//    pickupBlobs[i].RenderForHUD( RenderStyle::outline_front );
			//}
		}
	}
}
