﻿// Barracks

#include "ProductionCommon.as";
#include "Help.as"
#include "WARCosts.as";
#include "ClassSelectMenu.as";
#include "StandardRespawnCommand.as";

void onInit( CBlob@ this )
{
	InitClasses( this );
	this.set_TileType("background tile", CMap::tile_castle_back);					
	SetHelp( this, "help use", "", "Change class. Hold \n\n         $KEY_E$" ); 
	this.Tag("change class store inventory");
	this.getShape().getConsts().mapCollisions = false;
	this.getSprite().getConsts().accurateLighting = true;
}

void InitClasses( CBlob@ this )
{
	AddIconToken( "$builder_class_icon$", "GUI/MenuItems.png", Vec2f(32,32), 8 );
	AddIconToken( "$knight_class_icon$", "GUI/MenuItems.png", Vec2f(32,32), 12 );
	AddIconToken( "$archer_class_icon$", "GUI/MenuItems.png", Vec2f(32,32), 16 );
	AddIconToken( "$change_class$", "GUI/InteractionIcons.png", Vec2f(32,32), 12, 2 );
	addPlayerClass( this, "Builder", "$builder_class_icon$", "builder", "Build ALL the towers." );
	addPlayerClass( this, "Knight", "$knight_class_icon$", "knight", "Hack and Slash." );
	addPlayerClass( this, "Archer", "$archer_class_icon$", "archer", "The Ranged Advantage." );
}
   
// leave a pile of stone	after death
void onDie(CBlob@ this)
{
	if (getNet().isServer())
	{
		CBlob@ blob = server_CreateBlob( "mat_stone", this.getTeamNum(), this.getPosition() );
		if (blob !is null)
		{
			blob.server_SetQuantity( COST_STONE_BARRACKS/2 );
		}
	}
}

bool isInRadius( CBlob@ this, CBlob @caller )
{
	return ((this.getPosition() - caller.getPosition()).Length() < this.getRadius()*2.0f + caller.getRadius());
}

bool canChangeClass( CBlob@ this, CBlob @caller )
{
	return isInRadius( this, caller );
}

void GetButtonsFor( CBlob@ this, CBlob@ caller )
{
	CBitStream params;
	params.write_u16( caller.getNetworkID() );

	if (canChangeClass( this, caller ))	 
	{			
		if ((this.getPosition() - caller.getPosition()).Length() < 18.0f) {
			BuildRespawnMenuFor( this, caller );
		}
		else {
			caller.CreateGenericButton( "$change_class$", this.getPosition(), this, this.getCommandID("class menu"), "Change class", params );
		}
	}
}

void onCommand( CBlob@ this, u8 cmd, CBitStream @params )
{
	{
		onRespawnCommand( this, cmd, params );
	}
}

//sprite - foreground layer :)

void onInit(CSprite@ this)
{
	this.SetZ(-50); //background
	
	CBlob@ blob = this.getBlob();
	CSpriteLayer@ front = this.addSpriteLayer( "front layer", this.getFilename() , this.getFrameWidth(), this.getFrameHeight(), blob.getTeamNum(), blob.getSkinNum() );

    if (front !is null)
    {
        Animation@ anim = front.addAnimation( "default", 0, false );
        anim.AddFrame(0);
        anim.AddFrame(1);
        anim.AddFrame(2);
        front.SetRelativeZ( 1000 );
    }
}
