// Saw logic

#include "Hitters.as"

//function for blending things
void Blend( CBlob@ this, CBlob@ tobeblended )
{
    if (this is tobeblended) {
        return;
    }

    //make plankfrom wooden stuff
    if ( tobeblended.getName() == "log" )
    {
        CBlob @wood = server_CreateBlob( "mat_wood", this.getTeamNum(), this.getPosition() + Vec2f(0,12) );	
        if (wood !is null)
        {
            wood.server_SetQuantity( (tobeblended.getHealth() / 0.014f) + 1 );
            wood.setVelocity( Vec2f(0, -4.0f) );
        }

        this.getSprite().PlaySound( "SawLog.ogg" );
    }
    else {
        this.getSprite().PlaySound( "SawOther.ogg" );
    }

    //give no fucks about teamkilling
    tobeblended.server_SetHealth(-1.0f);
    tobeblended.server_Die();
    CSprite@ s = tobeblended.getSprite();

    if (s !is null) {
        s.Gib();
    }
}

bool canSaw(CBlob@ this, CBlob@ blob)
{
	if (blob.getRadius() > 30.0f || blob.getShape().isStatic()) {
        return false;
    }

    Vec2f pos = this.getPosition();
    Vec2f bpos = blob.getPosition();
    
    Vec2f off = (bpos - pos);
	f32 len = off.Normalize();
	
	f32 dot = off * (Vec2f(0,-1).RotateBy(this.getAngleDegrees(), Vec2f()));	
    
    //flesh blobs have to be fed into the saw part
    if (blob.hasTag("flesh"))
    {
		return (dot > 0.8f);
	}

	string name = blob.getName();
	
	if (name == "saw") //saws only saw from above
	{
		return (dot > 0.7);
	}
	
    if (!blob.hasTag("invincible") &&
        name != "wooden_door" &&
        name != "mat_wood" &&
        name != "tree_bushy" &&
        name != "tree_pine" )
    {
		return true;
	}
	
	return false;
}

void onHitBlob( CBlob@ this, Vec2f worldPoint, Vec2f velocity, f32 damage, CBlob@ hitBlob, u8 customData )
{
    if (hitBlob !is null)
    {
        Blend( this, hitBlob );
    }
}

//we have contact!
void onCollision( CBlob@ this, CBlob@ blob, bool solid )
{
    if (blob is null || !getNet().isServer() || this.isAttached() || blob.isAttached()) {
        return;
    }

    if(canSaw(this,blob))
    {
		Vec2f pos = this.getPosition();
		Vec2f bpos = blob.getPosition();
        this.server_Hit( blob, bpos, bpos - pos, 0.0f, Hitters::saw );
    }
}

//sprite update
void onInit( CSprite@ this )
{
    CSpriteLayer@ chop = this.addSpriteLayer( "chop", "Sprites/world.png", 16, 16 );

    if (chop !is null)
    {
        Animation@ anim = chop.addAnimation( "default", 0, true );
        anim.AddFrame(102);
        chop.SetAnimation( anim );
        chop.SetRelativeZ(-0.01f);
        chop.SetOffset(Vec2f(-2.0f,0.0f));
    }

    CSpriteLayer@ back = this.addSpriteLayer( "back", "Sprites/world.png", 24, 16 );

    if (back !is null)
    {
        Animation@ anim = back.addAnimation( "default", 0, true );
        anim.AddFrame(143);
        back.SetAnimation( anim );
        back.SetRelativeZ(-0.1f);
    }

    this.getBlob().getShape().SetRotationsAllowed(false);
}

void onTick( CSprite@ this )
{
    //spin saw blade
    CSpriteLayer@ chop = this.getSpriteLayer( "chop" );

    if (chop !is null)
    {
        chop.RotateBy(20.0f,Vec2f(-0.5,0.5));
    }
}
