﻿// Workbench

#include "Requirements.as"
#include "Help.as"
#include "ShopCommon.as";
#include "Descriptions.as";
#include "WARCosts.as";
#include "CheckSpam.as";

void onInit( CBlob@ this )
{	
	SetHelp( this, "help use", "", "Hold or tap to use \n\n         $KEY_E$" ); 

	this.getSprite().SetZ(-50); //background
	this.getShape().getConsts().mapCollisions = false;

	InitWorkshop( this );
}


void InitWorkshop( CBlob@ this )
{
	this.set_Vec2f("shop offset", Vec2f(0, 0));
	this.set_Vec2f("shop menu size", Vec2f(4,8));


	{
		ShopItem@ s = addShopItem( this, "Kitchen", "$kitchen$", "kitchen", descriptions[39], false, true );
		AddRequirement( s.requirements, "blob", "mat_wood", "Wood", COST_WOOD_KITCHEN );
	}
	{
		ShopItem@ s = addShopItem( this, "Nursery", "$nursery$", "nursery", descriptions[40], false, true );
		AddRequirement( s.requirements, "blob", "mat_wood", "Wood", COST_WOOD_NURSERY );
	}

	{
		ShopItem@ s = addShopItem( this, "Barracks", "$barracks$", "barracks", descriptions[41], false, true );
		AddRequirement( s.requirements, "blob", "mat_stone", "Stone", COST_STONE_BARRACKS );
	}	  
	{
		ShopItem@ s = addShopItem( this, "Factory", "$factory$", "factory", descriptions[38], false, true );
		AddRequirement( s.requirements, "blob", "mat_wood", "Wood", COST_WOOD_FACTORY );
	}
					
	{
		ShopItem@ s = addShopItem( this, "Storage", "$storage$", "storage", descriptions[42], false, true );
		AddRequirement( s.requirements, "blob", "mat_wood", "Wood", COST_WOOD_STORAGE );
	}
	{
		ShopItem@ s = addShopItem( this, "Transport Tunnel", "$tunnel$", "tunnel", descriptions[34], false, true );
		AddRequirement( s.requirements, "blob", "mat_stone", "Stone", COST_STONE_TUNNEL );
	}

	{	 
		ShopItem@ s = addShopItem( this, "Lantern", "$lantern$", "lantern", descriptions[9], false );
		AddRequirement( s.requirements, "blob", "mat_wood", "Wood", COST_WOOD_LANTERN );
	}
	{
		ShopItem@ s = addShopItem( this, "Bucket", "$bucket$", "bucket", descriptions[36], false );
		AddRequirement( s.requirements, "blob", "mat_wood", "Wood", COST_WOOD_BUCKET );
	}
	{
		ShopItem@ s = addShopItem( this, "Crate", "$crate$", "crate", descriptions[18], false );
		AddRequirement( s.requirements, "blob", "mat_wood", "Wood", COST_WOOD_CRATE );
	}
	{
		ShopItem@ s = addShopItem( this, "Ladder", "$ladder$", "ladder", descriptions[16], false );
		AddRequirement( s.requirements, "blob", "mat_wood", "Wood", COST_WOOD_LADDER );
	}

}

void onCommand( CBlob@ this, u8 cmd, CBitStream @params )
{
	bool isServer = getNet().isServer();

	if (cmd == this.getCommandID("shop buy"))
	{
		u16 callerID;
		if (!params.saferead_u16(callerID))
			return;
		bool spawnToInventory = params.read_bool();
		bool spawnInCrate = params.read_bool();
		bool producing = params.read_bool();
		string blobName = params.read_string();		
		u8 s_index = params.read_u8();

		// check spam
		if (isSpammed( blobName, this.getPosition() ))
		{
			MessageBox( "There is too many " + blobName + "s made here sorry.", false );
		}
		else
		{
			this.getSprite().PlaySound("/ConstructShort" );
		}
	}
}

//sprite - planks layer

void onInit(CSprite@ this)
{
	this.SetZ(50); //foreground
	
	CBlob@ blob = this.getBlob();
	CSpriteLayer@ planks = this.addSpriteLayer( "planks", this.getFilename() , 16, 16, blob.getTeamNum(), blob.getSkinNum() );

    if (planks !is null)
    {
        Animation@ anim = planks.addAnimation( "default", 0, false );
        anim.AddFrame(6);
        planks.SetOffset( Vec2f(3.0f,-7.0f) );
        planks.SetRelativeZ( -100 );
    }
}
