// Keg logic
#include "Help.as";

void onInit( CBlob@ this )
{
    this.getShape().getVars().waterDragScale = 8.0f;
	this.getShape().getConsts().collideWhenAttached = true;
    AttachmentPoint@ att = this.getAttachments().getAttachmentPointByName("PICKUP");
    att.SetKeysToTake( key_action1 | key_action2 );
    att.SetMouseTaken( false );
    this.set_f32("explosive_radius",116.0f);
    this.set_f32("explosive_damage",10.0f);
    this.set_string("custom_explosion_sound", "Entities/Items/Explosives/KegExplosion.ogg");
    this.setTeamNum(-1);
    this.set_f32("map_damage_radius", 84.0f);
    this.set_f32("map_damage_ratio", 0.4f);
    this.set_bool("map_damage_raycast", true);
	this.set_f32("keg_time", 300.0f);
    this.Tag("medium weight");
    
    CSpriteLayer@ fuse = this.getSprite().addSpriteLayer( "fuse", "Keg.png" , 16, 16, 0, 0 );

	if (fuse !is null)
	{
		fuse.addAnimation("default",0,false);
		int[] frames = {8,9,10,11,12,13};
		fuse.animation.AddFrames(frames);
		fuse.SetOffset(Vec2f(3,-4));
	}

	SetHelp( this, "help pickup", "", "$keg$ Pick up \n\n         $KEY_C$" ); 
	SetHelp( this, "help activate", "", "$keg$ Light \n\n         $KEY_SPACE$", "" ); 
	SetHelp( this, "help throw", "", "$keg$ THROW!\n\n       $KEY_SPACE$", "", 2 ); 

	this.getCurrentScript().runFlags |= Script::remove_after_this;
}

//sprite update

void onTick( CSprite@ this )
{
    CBlob@ blob = this.getBlob();
    
    this.animation.frame = (this.animation.getFramesCount()) * (1.0f - (blob.getHealth() / blob.getInitialHealth()));
    
    s32 timer = blob.get_s32("explosion_timer") - getGameTime();

    if (timer < 0) {
        return;
    }
    
    CSpriteLayer@ fuse = this.getSpriteLayer( "fuse" );
    
    if (fuse !is null)
    {
		fuse.animation.frame = 1 + (fuse.animation.getFramesCount() - 1) * (1.0f - ((timer) / f32(blob.get_f32("keg_time"))));
	}
    
}
