// Lantern script


void onInit( CBlob@ this )
{
    this.SetLight( true );
    this.SetLightRadius( 64.0f );
    this.SetLightColor( SColor(255, 255, 240, 171 ) );
    this.addCommandID("light on");
    this.addCommandID("light off");
    AddIconToken( "$lantern on$", "Lantern.png", Vec2f(8,8), 0 );
    AddIconToken( "$lantern off$", "Lantern.png", Vec2f(8,8), 3 );

	this.Tag("fire source");

	this.getCurrentScript().runFlags |= Script::tick_inwater;
	this.getCurrentScript().tickFrequency = 11;
}

void onTick( CBlob@ this )
{
    if (this.isLight() && this.isInWater())
    {
        Light( this, false );
    }
}

void Light( CBlob@ this, bool on )
{
    if (!on)
    {
        this.SetLight( false );
        this.getSprite().SetAnimation( "nofire");
    }
    else
    {
        this.SetLight( true );
        this.getSprite().SetAnimation( "fire");
    }
}

void GetButtonsFor( CBlob@ this, CBlob@ caller )
{
	if (!this.isAttached())
	{
		if (this.isLight()) {
			caller.CreateGenericButton( "$lantern off$", Vec2f(0,0), this, this.getCommandID("light off"), "Lantern Off" );
		}
		else if (!this.isInWater()) {
			caller.CreateGenericButton( "$lantern on$", Vec2f(0,0), this, this.getCommandID("light on"), "Lantern On" );
		}
	}
}

void onCommand( CBlob@ this, u8 cmd, CBitStream @params )
{
    if( cmd == this.getCommandID("light on") && !this.isInWater())
    {
        Light( this, true );
    }
    else if( cmd == this.getCommandID("light off"))
    {
        Light( this, false );
    }
}
