
// consts for use everywhere scrolls are made - TODO config file

const s32 cost_crappy 	= 50;
const s32 cost_medium 	= 80;
const s32 cost_big	 	= 150;
const s32 cost_super 	= 300;

//scroll definitions

class ScrollDef
{
	string name;
	ShopItem[] techs;
	string[] scripts;

	ScrollDef() {}
}

//scroll sets

//maps of ScrollDefs
dictionary all_scrolls;
string[] all_scrolls_names;

dictionary crappy_scrolls;
string[] crappy_scrolls_names;

dictionary medium_scrolls;
string[] medium_scrolls_names;

dictionary super_scrolls;
string[] super_scrolls_names;

bool scrolls_initialised = false;

void copyFrom( dictionary@ from, string key, dictionary@ to )
{
	ScrollDef@ temp;
	from.get(key, @temp);
	to.set(key,temp);
}

void scrolls_Setup()
{
	if (scrolls_initialised) return; //we've already done it!

	const f32 m = sv_test ? 0.2f : 0.6f;

	//econ
	{
		ScrollDef def;		
		def.name = "Saw";
		addScrollTechToArray( "Mill Saw", "saw", m*30, false, 1, @def.techs );
		all_scrolls.set( "saw", def );
	}

	{
		ScrollDef def;		
		def.name = "Drill";
		addScrollTechToArray( "Mining Drill", "drill", m*60, false, 1, @def.techs);
		all_scrolls.set( "drill", def );
	}

	
	//siege
	{
		ScrollDef def;
		def.name = "Ballista";
		addScrollTechToArray( "Ballista", "ballista", 			m*60, true, 1, @def.techs );
		addScrollTechToArray( "Ballista Bolts", "mat_bolts", 	m*60, false, 1, @def.techs );
		all_scrolls.set( "ballista", def );
	}
	
	{
		ScrollDef def;
		def.name = "Catapult";
		addScrollTechToArray( "Catapult", "catapult", 	m*60, true, 1, @def.techs );
		addScrollTechToArray( "Boulder", "boulder", 	m*60, false, 1, @def.techs );
		all_scrolls.set( "catapult", def );
	}

	{
		ScrollDef def;
		def.name = "Mounted Bow";
		addScrollTechToArray( "Mounted Bow", "mounted_bow", m*60, true, 1, @def.techs );
		addScrollTechToArray( "Arrows", "mat_arrows", 	m*60, false, 1, @def.techs );
		all_scrolls.set( "mounted bow", def );
	}

	//boats

	{
		ScrollDef def;
		def.name = "Longboat";
		addScrollTechToArray( "Longboat", "longboat", 	m*60, true, 1, @def.techs );
		all_scrolls.set( "longboat", def );
	}

	{
		ScrollDef def;
		def.name = "War Boat";
		addScrollTechToArray( "War Boat", "warboat", 	m*60, true, 1, @def.techs );
		all_scrolls.set( "armoured boat", def );
	}
	
	//item kits
	{
		ScrollDef def;
		def.name = "Military Supplies";
		addScrollTechToArray( "Bombs", "mat_bombs", 	m*60, false, 3, @def.techs );
		addScrollTechToArray( "Arrows", "mat_arrows", 	m*60, false, 3, @def.techs );
		all_scrolls.set( "military basics", def );
	}

	{
		ScrollDef def;
		def.name = "Demolition Technology";
		addScrollTechToArray( "Keg", "keg", 		m*60, false, 1, @def.techs );
		addScrollTechToArray( "Minikeg", "minikeg", m*60, false, 2, @def.techs );
		all_scrolls.set( "explosives", def );
	}

	{
		ScrollDef def;
		def.name = "Pyro Technology";
		addScrollTechToArray( "Fire Arrows", "mat_firearrows", 	m*60, false, 2, @def.techs );
		addScrollTechToArray( "Fire Satchel", "satchel", 		m*60, false, 1, @def.techs );
		addScrollTechToArray( "Lantern", "lantern", 		m*60, false, 1, @def.techs );
		all_scrolls.set( "pyro", def );
	}
	
	//spells

	{
		ScrollDef def;
		def.name = "Scroll of Sudden Gib";
		def.scripts.push_back( "ScrollSuddenGib.as" );
		all_scrolls.set( "gib", def );
	}
	
	// make crappy scrolls ----------------------------------------------------

	copyFrom( all_scrolls, "saw", crappy_scrolls );
	copyFrom( all_scrolls, "drill", crappy_scrolls );
	copyFrom( all_scrolls, "military basics", crappy_scrolls );
	
	// make medium scrolls ----------------------------------------------------

	copyFrom( all_scrolls, "saw", medium_scrolls );
	copyFrom( all_scrolls, "drill", medium_scrolls );
	copyFrom( all_scrolls, "ballista", medium_scrolls );
	copyFrom( all_scrolls, "catapult", medium_scrolls );
	copyFrom( all_scrolls, "longboat", medium_scrolls );
	copyFrom( all_scrolls, "armoured boat", medium_scrolls );
	copyFrom( all_scrolls, "explosives", medium_scrolls );
	copyFrom( all_scrolls, "pyro", medium_scrolls );
	
	// make super scrolls ----------------------------------------------------

	copyFrom( all_scrolls, "gib", super_scrolls );
	
	//build the name arrays
	all_scrolls_names = all_scrolls.getKeys();
	crappy_scrolls_names = crappy_scrolls.getKeys();
	medium_scrolls_names = medium_scrolls.getKeys();
	super_scrolls_names = super_scrolls.getKeys();

	scrolls_initialised = true;
}
