// Materials
#include "Help.as";

// use this.Tag("do not set materials") to prevent the amount changing.

void onInit( CBlob@ this )
{
    int max = 250; // default
    string name = this.getName();
    bool set = false;

	this.Tag("material");

    if (name == "mat_arrows")
    {
        max = 25;
        set = true;
    }
    else if (name == "mat_firearrows") {
        max = 5;
        set = true;		
		SetHelp( this, "help switch", "archer", "$mat_firearrows$ \n\nChange to fire arrows. Hold and select.\n\n       $KEY_F$", "$mat_firearrows$ \n\nRequires Archer and LANTERN to use." ); 
    }
    else if (name == "mat_bombs") {
        max = 1;
		SetHelp( this, "help activate", "knight", "$mat_bombs$ Light bomb.\n\n       $KEY_SPACE$", "$mat_bombs$ Only Knights can use bombs." ); 
    }
    else if (name == "mat_bolts")
    {
        max = 10;
        set = true;
    }
    else if (this.getQuantity() == 1) { // hack: fix me!
        set = true;
    }

	if (name == "mat_wood")
	{
		SetHelp( this, "help switch", "builder", "$mat_wood$ \n\nHold to select wood blocks to build with.\n\n       $KEY_F$", "$mat_wood$ \n\nRequires Builder to use." ); 
	}
	else if (name == "mat_stone")
	{
		//SetHelp( this, "help switch", "builder", "$mat_stone$ \n\nHold to select stone blocks to build with.\n\n       $KEY_F$", "$mat_stone$ \n\nRequires Builder to use." ); 			
	}

    if (getNet().isServer() && set && !this.hasTag("do not set materials"))
    {
        this.server_SetQuantity( max );
    }

    this.maxQuantity = max;

	this.getShape().getVars().waterDragScale = 20.0f;

    // force frame update
    onQuantityChange( this, -1 );
}

void onQuantityChange( CBlob@ this, int oldQuantity )
{
    UpdateFrame( this.getSprite() );

    if (getNet().isServer())
    {
        int quantity = this.getQuantity();

        // safety, we don't want 0 mats
        if (quantity == 0) {
            this.server_Die();
        }
    }
}

void UpdateFrame( CSprite@ this )
{
    // set the frame according to the material quantity
    Animation@ anim = this.getAnimation("default");

    if (anim !is null)
    {
        u16 max = this.getBlob().maxQuantity;
        int frames = anim.getFramesCount();
        int quantity = this.getBlob().getQuantity();
        f32 div = float(max/4);
        int frame = div < 0.01f ? 0 : Maths::Min( frames-1, int(Maths::Floor( float(quantity) / div )));
        anim.SetFrameIndex( frame );
        CBlob@ blob = this.getBlob();
        blob.SetInventoryIcon( blob.getSprite().getConsts().filename, anim.getFrame(frame), Vec2f(blob.getSprite().getConsts().frameWidth, blob.getSprite().getConsts().frameHeight) );
    }
}
