
// eating other things
// setup: set in properties a string[] 

#include "Hitters.as";

void onInit(CBlob@ this)
{
	if (!this.exists("names to eat"))
	{
		string[] names;
		this.set("names to eat", names);
	}
	
	if (!this.exists("tags to eat"))
	{
		string[] tags;
		this.set("tags to eat", tags);
	}
	
	if (!this.exists("bite damage"))
		this.set_f32("bite damage", 1.0f);
		
	if (!this.exists("bite hitter"))
		this.set_u8("bite hitter", Hitters::bite);
		
		
	if (!this.exists("bite sound"))
		this.set_string("bite sound", "Entities/Zombies/ZombieBite");

	this.getCurrentScript().removeIfTag	= "dead";
 
}

void onCollision( CBlob@ this, CBlob@ blob, bool solid, Vec2f normal, Vec2f point1 )
{
	if (blob is null) return;
	bool facing_left = this.isFacingLeft();
	Vec2f pos = this.getPosition();
	
	//TODO: mouth position & radius
	bool can_eat = facing_left ? point1.x < pos.x : point1.x > pos.x;
	
	if (can_eat)
	{
		string[]@ names;
		this.get("names to eat", @names);
		
		can_eat = names.find(blob.getName()) != -1;
		
		if (!can_eat) //find a tag
		{
			string[]@ tags;
			this.get("tags to eat", @tags);
			for (uint step = 0; step < tags.length; ++step)
			{
				if (blob.hasTag(tags[step]))
				{
					can_eat = true;
					break;
				}
			}
		}
		
		if (can_eat)
		{
			Vec2f hitvel = Vec2f( facing_left ? -1.0: 1.0, 0.0f );
			this.server_Hit( blob, point1, hitvel, this.get_f32("bite damage"), this.get_u8("bite hitter"), true);
			
		}
	}
}
			  
void onHitBlob( CBlob@ this, Vec2f worldPoint, Vec2f velocity, f32 damage, CBlob@ hitBlob, u8 customData )
{		 
	if (damage > 0.0f)
	{
		this.getSprite().PlaySound( this.get_string("bite sound") );
	}
}