
//script for a scary shark

#include "AquaticAnimalConsts.as";

//sprite

void onInit(CSprite@ this)
{
    this.ReloadSprites(0,0); //always blue
}

void onTick(CSprite@ this)
{
	CBlob@ blob = this.getBlob();
    
    if (!blob.hasTag("dead"))
    {
		if (blob.isKeyPressed(key_left) ||
			blob.isKeyPressed(key_right) ||
			blob.isKeyPressed(key_up) ||
			blob.isKeyPressed(key_down))
		{
			this.SetAnimation("default");
		}
		else if (this.isAnimationEnded())
		{
			this.SetAnimation("idle");
		}
	}
	else
	{
		this.SetAnimation("dead");
		this.getCurrentScript().runFlags |= Script::remove_after_this;
	}
}

//blob

void onInit(CBlob@ this)
{
	//for EatOthers
	string[] tags = {"player", "flesh"};
	this.set("tags to eat", tags);
	
	this.set_f32("bite damage", 1.5f);
	
	//for aquatic animal
	this.set_f32(terr_rad_property, 64.0f);
	this.set_f32(target_searchrad_property, 96.0f);
	
	this.set_u8(personality_property,AGGRO_BIT);
	
	this.getBrain().server_SetActive( true );
	
	//for steaks
	this.set_u8("number of steaks", 5);
	
	//for shape
	this.getShape().SetRotationsAllowed(false);
	
	//for flesh hit
	this.set_f32("gib health", -4.0f);
	
	this.Tag("flesh");

	this.getCurrentScript().runFlags |= Script::tick_blob_in_proximity;
	this.getCurrentScript().runProximityTag = "player";
	this.getCurrentScript().runProximityRadius = 320.0f;
	this.getCurrentScript().runFlags |= Script::tick_not_attached;
}

bool canBePickedUp( CBlob@ this, CBlob@ byBlob )
{
    return false; //maybe make a knocked out state? for loading to cata?
}


void onTick(CBlob@ this)
{
	f32 x = this.getVelocity().x;
	
	if (Maths::Abs(x) > 1.0f)
	{
		this.SetFacingLeft( x < 0 );
	}
	else
	{
		if (this.isKeyPressed(key_left))
			this.SetFacingLeft( true );
		if (this.isKeyPressed(key_right))
			this.SetFacingLeft( false );
	}
		
}
