// Grain logic

#include "../Scripts/canGrow.as";

void onInit( CBlob@ this )
{
    this.SetFacingLeft(Random(2) == 0);
	if (this.hasTag("instant_grow"))
	{
		this.server_SetHealth( this.getInitialHealth() );
		GrowGrain( this );
	}
	else
		this.server_SetHealth( 0.01f );
	this.getShape().SetStatic(true);
	this.getShape().getConsts().mapCollisions = false;
	this.getCurrentScript().tickFrequency = 30;
}


void onTick( CBlob@ this )
{
    bool grown = this.getHealth() >= this.getInitialHealth() - 0.02f;
	if ( !grown )
    {			
		if (getNet().isServer() && canGrowAt( this,(this.getPosition())))
		{
			f32 rate = 1.0f / getTicksASecond();
			this.server_Heal(rate);
		}
	}
	else
    {
		GrowGrain( this );
    }	       
}

void GrowGrain( CBlob @this )
{
	for (int i = 0; i < 3; i++)
	{
		Vec2f offset;			 
		switch(i)
		{
		case 0: offset = Vec2f(0,-16); break;			 
		case 1: offset = Vec2f(3,-10); break;			 
		case 2: offset = Vec2f(-3,-5); break;
		}

		CSpriteLayer@ grain = this.getSprite().addSpriteLayer( "grain", "Entities/Natural/Farming/Grain.png" , 8, 8 );

		if (grain !is null)
		{
			Animation@ anim = grain.addAnimation( "default", 0, false );
			anim.AddFrame(0);
			grain.SetAnimation("default");
			grain.SetOffset( offset );
			grain.SetRelativeZ( 0.01f * (Random(3) == 0 ? -1 : 1) );
		}
	}

	this.Tag("has grain");
	this.getCurrentScript().runFlags |= Script::remove_after_this;
}