// Sign logic

namespace Sign
{
enum State
{
    blank = 0,
    written
}
}

void onInit( CBlob@ this )
{
    //setup blank state
    this.set_u8("state", Sign::blank);

    if (!this.exists("text")) {
        this.set_string("text", "The big brown fox jumped over the shaggy chocolate.");
    }

    this.getSprite().SetAnimation("written");

	this.getCurrentScript().runFlags |= Script::tick_myplayer;
}

void onRender( CSprite@ this )
{
	CBlob@ blob = this.getBlob();
	if (blob is null) return;
	
	CBlob@ localBlob = getLocalPlayerBlob();
    Vec2f pos2d = blob.getScreenPos();

	if (localBlob is null) return;

    if (
                ((localBlob.getPosition() - blob.getPosition()).Length() < (localBlob.getRadius() + blob.getRadius())) &&
                (!getHUD().hasButtons()) )
    {
        // draw drop time progress bar
        int top = pos2d.y - 2.5f*blob.getHeight() - 20.0f;
        int margin = 4;
        Vec2f dim;
        string label = blob.get_string("text");
        label += "\n";
        GUI::GetTextDimensions( label , dim );
        dim.x = Maths::Min( dim.x, 200.0f );
        dim.x += margin;
        dim.y += margin;
        dim.y *= 1.8f;
        Vec2f upperleft(pos2d.x-dim.x/2, top - 2*dim.y);
        Vec2f lowerright(pos2d.x+dim.x/2, top - dim.y);
        GUI::DrawText( label, Vec2f(upperleft.x + margin, upperleft.y + margin+margin),
                       Vec2f(upperleft.x + margin + dim.x, upperleft.y + margin + dim.y),
                       SColor(255, 0, 0, 0), false, false, true );
    }
}
