// Trader brain

#define SERVER_ONLY

#include "/Entities/Common/Emotes/EmotesCommon.as"


void onInit( CBrain@ this )
{
    CBlob @blob = this.getBlob();
}

void onTick( CBrain@ this )
{
    CBlob @blob = this.getBlob();

    if (this.getTarget() is null || this.getTarget().hasTag("dead")) {
        FindNewTarget(this, blob);
    }

    if (this.getTarget() !is null)
    {	        
        GoToBlob(this,  this.getTarget() );        
    }
}

void FindNewTarget( CBrain@ this, CBlob @blob )
{
    this.SetTarget( getLocalPlayerBlob() );
    return;
}

void Repath( CBrain@ this )
{
    this.SetPathTo( this.getTarget().getPosition(), false );
}

void GoToBlob( CBrain@ this, CBlob @target )
{
    CBlob @blob = this.getBlob();
    Vec2f targetVector = target.getPosition() - blob.getPosition();
    f32 targetDistance = targetVector.Length();

	if ( targetDistance > target.getRadius()) 
	{
		// check if we have a clear area to the target
		JustGo( this, target.getPosition() );
   
		// face the enemy
		blob.setAimPos( target.getPosition() );
		// jump over small blocks
		Vec2f pos = blob.getPosition();

		if ( (blob.isKeyPressed( key_right ) && getMap().isTileSolid( pos + Vec2f(1.3f*blob.getRadius(), blob.getRadius())*1.0f ) ) ||
				(blob.isKeyPressed( key_left ) && getMap().isTileSolid( pos + Vec2f(-1.3f*blob.getRadius(), blob.getRadius())*1.0f ) ) )
		{
			blob.setKeyPressed( key_up, true );
		}
	}
}

void JustGo( CBrain@ this, Vec2f point )
{
    CBlob @blob = this.getBlob();
    Vec2f mypos = blob.getPosition();
    f32 distance = (point - mypos).Length();

    if (distance > 1.4f * blob.getRadius())
    {
        if (point.x < mypos.x) {
            blob.setKeyPressed( key_left, true );
        }
        else {
            blob.setKeyPressed( key_right, true );
        }

        this.getBlob().Untag("at post");
    }
    else {
        this.getBlob().Tag("at post");
    }

    if (point.y + getMap().tilesize + blob.getRadius() < mypos.y) {
        blob.setKeyPressed( key_up, true );
    }
}
