// TDM Ruins logic

#include "ClassSelectMenu.as"
#include "StandardRespawnCommand.as"
#include "Help.as";

void onInit( CBlob@ this )
{
    this.CreateRespawnPoint( "ruins", Vec2f(0.0f, 16.0f) );
	AddIconToken( "$knight_class_icon$", "GUI/MenuItems.png", Vec2f(32,32), 12 );
	AddIconToken( "$archer_class_icon$", "GUI/MenuItems.png", Vec2f(32,32), 16 );
    //TDM classes
    addPlayerClass( this, "Knight", "$knight_class_icon$", "knight", "Hack and Slash." );
    addPlayerClass( this, "Archer", "$archer_class_icon$", "archer", "The Ranged Advantage." );
    this.getShape().SetStatic(true);
    this.getShape().getConsts().mapCollisions = false;
    this.addCommandID("class menu");

	SetHelp( this, "help use", "", "Change class.\n\n       $KEY_E$" ); 

	this.getSprite().SetZ( -50.0f ); // push to background
}

bool canChangeClass( CBlob@ this, CBlob @caller )
{
    return ((this.getPosition() - caller.getPosition()).Length() < this.getRadius() + caller.getRadius());
}

void onCommand( CBlob@ this, u8 cmd, CBitStream @params )
{
    if (cmd == this.getCommandID("class menu"))
    {
        u16 callerID = params.read_u16();
        CBlob@ caller = getBlobByNetworkID( callerID );

        if (caller !is null && caller.isMyPlayer())     {
            BuildRespawnMenuFor( this, caller );
        }
    }
    else {
        onRespawnCommand( this, cmd, params );
    }
}

void GetButtonsFor( CBlob@ this, CBlob@ caller )
{
    if (canChangeClass( this, caller )) 
	{
		Vec2f pos = this.getPosition();
		if ((pos - caller.getPosition()).Length() < this.getRadius()) {
			BuildRespawnMenuFor( this, caller );
		}
		else 
		{
			CBitStream params;
			params.write_u16( caller.getNetworkID() );
			caller.CreateGenericButton( "$change_class$", Vec2f(0, 12), this, this.getCommandID("class menu"), "Change class", params );
		}
    }

    // warning: if we don't have this button just spawn menu here we run into that infinite menus game freeze bug
}
