// Tent logic

#include "/Entities/Common/Respawning/StandardRespawnCommand.as"

void onInit( CBlob@ this )
{
    this.CreateRespawnPoint( "tent", Vec2f(0.0f, -4.0f) );
    AddIconToken( "$builder_class_icon$", "Entities/Characters/Sprites/ClassIcons.png", Vec2f(16,16), 0 );
    AddIconToken( "$knight_class_icon$", "Entities/Characters/Sprites/ClassIcons.png", Vec2f(16,16), 1 );
    AddIconToken( "$archer_class_icon$", "Entities/Characters/Sprites/ClassIcons.png", Vec2f(16,16), 2 );
    addPlayerClass( this, "Builder", "$builder_class_icon$", "builder", "Build structures and Machines." );
    addPlayerClass( this, "Knight", "$knight_class_icon$", "knight", "Hack and Slash." );
    addPlayerClass( this, "Archer", "$archer_class_icon$", "archer", "The Ranged Advantage." );
}

void GetButtonsFor( CBlob@ this, CBlob@ caller )
{
    // button for runner
    // create menu for class change
    if (canChangeClass( this, caller )) {
        CBitStream params;
        params.write_u16(caller.getNetworkID());
        caller.CreateGenericButton( 6, Vec2f(0,0), this, SpawnCmd::buildMenu, "Swap Class", params );
    }
}

bool canChangeClass( CBlob@ this, CBlob @caller )
{
    return ((this.getPosition() - caller.getPosition()).Length() < this.getRadius() + caller.getRadius());
}

void onCommand( CBlob@ this, u8 cmd, CBitStream @params )
{
    onRespawnCommand( this, cmd, params );
}