// settle after desired amount of time

//#define SERVER_ONLY

void onInit( CBlob@ this )
{
    this.set_s32( "settle_time", 0 );
    this.getShape().SetRotationsAllowed( true );
    this.getSprite().getConsts().accurateLighting = true;
}

void onTick( CBlob@ this )
{
    u32 time = this.get_s32( "settle_time" );
    CShape@ shape = this.getShape();

    // SETTLE

    if (!shape.isStatic() && !this.isAttached() && (this.isOnGround() || this.isOnWall()) )
    {
        Vec2f delta = shape.getVars().pos - shape.getVars().oldpos;
        f32 deltasq = delta.LengthSquared();

        if (deltasq < 5.0f)
        {
            time++;

            // move to grid

            if (time > 5)
            {
                Vec2f gridPos = getMap().getTileWorldPosition( shape.getVars().pos );
                gridPos.x += this.getWidth()/2 - 0.5f;
                gridPos.y += this.getHeight()/2;
                Vec2f delta = (gridPos - shape.getVars().pos);
                f32 deltalen = delta.Length();

                if (deltalen < 1.0f)
                {
                    delta.Normalize();
                    delta *= 1.0f;
                }

                this.AddForce( delta * 5.0f );

                // settle

                if (time > 39)
                {
                    if (deltalen < 2.0f && getMap().hasSupportAtPos( shape.getVars().pos, this.getMapTile() ) )
                    {
                        shape.SetStatic( true );
                        //print("BLOCK SETTLE");
                    }
                    else
                    {
                        //print("BLOCK DIE");
                        this.server_Die();
                    }

                    time = 0;
                }
            }
        }
        else
        {
            if (time > 5) {
                time = 5;
            }

            time--;
        }
    }
    else {
        time = 0;
    }

    this.set_s32( "settle_time", time );

    // UNSETTLE

    if (shape.isStatic())
    {
        //  print("SUPP " + shape.getCurrentSupport() );
        f32 support = shape.getCurrentSupport();

        if (support < 0.05f)
        {
            //print("BLOCK UNSETTLE");
            shape.SetStatic( false );
        }

        // put tile
        //this.getMap().server_SetTile( this.getPosition(), this.get_u8("tile") );
        //this.server_Die();
    }
}