#include "Hitters.as"

void onInit(CBlob@ this)
{
	this.Tag("place norotate");
	
	this.getCurrentScript().tickFrequency = 3;
	this.getCurrentScript().runFlags |= Script::tick_not_attached;
	this.getSprite().SetZ(-10.0f); //why you wont work?!
}

void onTick(CBlob@ this)
{
    CMap@ map = getMap();
    Vec2f pos = this.getPosition();
    const f32 tilesize = map.tilesize;

    // destroy grass
    //if (map.isTileGrass( map.getTile( pos ) ) ) {
    //    map.server_DestroyTile( pos, 10.0f );
    //}

    // attached to side	
    if (!map.isTileSolid( pos + Vec2f(0.0f, tilesize)))
    {
        if (map.isTileSolid( pos + Vec2f(-tilesize, 0.0f))) {
            this.setAngleDegrees(90.0f);
        }
        else if (map.isTileSolid( pos + Vec2f(tilesize, 0.0f))) {
            this.setAngleDegrees(-90.0f);
        }
        else
        {
            this.setAngleDegrees(-180.0f);

            if (!map.isTileSolid( pos + Vec2f(0.0f, -tilesize)))
			{
				this.getCurrentScript().tickFrequency = 0;
				this.getShape().SetStatic(false);
            }
        }
    }
    else {
        this.setAngleDegrees(0.0f);
    }
}

//physics logic
void onCollision( CBlob@ this, CBlob@ blob, bool solid, Vec2f normal, Vec2f point )
{
    if (!getNet().isServer() || this.isAttached()) { // map collision? not server?
        return;
    }

    if (blob is null) // fall down and destroy on map collision
    {
		if (!this.getShape().isStatic()) {
			this.server_Hit( this, point, this.getVelocity(), 10.0f, Hitters::fall, true);		 
		}
        return;
    }

    if (!blob.hasTag("flesh")) { // only hit living things
        return;
    }	  

    f32 angle = this.getAngleDegrees();
    //printf("angle " + angle);
    Vec2f vel = blob.getVelocity();

    if (angle > -180.0f && angle < 0.0f)
    {
        f32 verDist = Maths::Abs( this.getPosition().y - blob.getPosition().y );

        if (normal.x > 0.5f && verDist < 6.1f && vel.x > 0.5f) {
            this.server_Hit( blob, point, vel*-1, 1.0f, Hitters::spikes, true);
        }
    }
    else if (angle > 0.0f && angle < 180.0f)
    {
        f32 verDist = Maths::Abs( this.getPosition().y - blob.getPosition().y );

        if (normal.x < 0.5f && verDist < 6.1f && vel.x < 0.5f) {
            this.server_Hit( blob, point, vel*-1, 1.0f, Hitters::spikes, true);
        }
    }
    else if (angle <= -180.0f)
    {
        f32 horizDist = Maths::Abs( this.getPosition().x - blob.getPosition().x );

        if (normal.y < 0.5f && horizDist < 6.1f && vel.y < 0.5f) {
            this.server_Hit( blob, point, vel*-1, 1.0f, Hitters::spikes, true);
        }
    }
    else
    {
        f32 horizDist = Maths::Abs( this.getPosition().x - blob.getPosition().x );

        //  printf( " n " + normal.y + " vel " + vel.y + " horizDist " + horizDist );
        if (normal.y > 0.5f && horizDist < 6.1f && vel.y > 0.5f) {
            this.server_Hit( blob, point, vel*-1, 1.0f, Hitters::spikes, true);
        }
        else if (this.getVelocity().y > 0.5f && horizDist < 6.1f ) { // falling down
            this.server_Hit( blob, point, vel*-1, this.getVelocity().y*2.0f, Hitters::spikes, true);
        }
    }
}

void onHitBlob( CBlob@ this, Vec2f worldPoint, Vec2f velocity, f32 damage, CBlob@ hitBlob, u8 customData )
{
    if (hitBlob !is null && hitBlob !is this && damage > 0.0f)
    {
        this.getSprite().PlaySound( CFileMatcher( "SpikesCut" ).getRandom() );
		if (!this.hasTag("bloody"))	{			
			this.getSprite().animation.frame += 3;
			this.Tag("bloody");
		}			
    }
}

void onHealthChange( CBlob@ this, f32 oldHealth )
{
	f32 hp = this.getHealth();
	f32 full_hp = this.getInitialHealth();
	int frame = (hp > full_hp * 0.9f) ? 0 : ( (hp > full_hp * 0.4f) ? 1 : 2);

	if (this.hasTag("bloody"))	{
		frame += 3;
	}	   
	this.getSprite().animation.frame = frame;
}

void onGib(CSprite@ this)
{
    ParticlesFromSprite( this );
}

bool canBePickedUp( CBlob@ this, CBlob@ byBlob )
{
    return false;
}
