#include "Hitters.as"

void onInit(CBlob@ this)
{
	this.getShape().SetRotationsAllowed( false );
    this.getSprite().getConsts().accurateLighting = true;
    this.set_bool("open", false);    
    this.Tag("place norotate");
	MakeDamageFrame( this );
	this.getCurrentScript().runFlags |= Script::tick_not_attached;	
}

void onHealthChange( CBlob@ this, f32 oldHealth )
{
	if (!isOpen(this))
	{
		MakeDamageFrame( this );
	}
}

void MakeDamageFrame( CBlob@ this )
{
	f32 hp = this.getHealth();
	f32 full_hp = this.getInitialHealth();
	int frame = (hp > full_hp * 0.9f) ? 0 : ( (hp > full_hp * 0.4f) ? 1 : 2);
	this.getSprite().animation.frame = frame;
}

bool isOpen( CBlob@ this )
{
	return !this.getShape().getConsts().collidable;
}

void setOpen( CBlob@ this, bool open )
{
	CSprite@ sprite = this.getSprite();

	if (open)
	{
		sprite.SetZ(-100.0f);
		sprite.animation.frame = 3;
		this.getShape().getConsts().collidable = false;
	}
	else
	{
		sprite.SetZ(100.0f);
		MakeDamageFrame(this);
		this.getShape().getConsts().collidable = true;
	}
}

bool doesCollideWithBlob( CBlob@ this, CBlob@ blob )
{
	if (blob.getTeamNum() == this.getTeamNum())
	{
		return !isOpen( this );
	}
	else
	{
		return !opensThis(this,blob) && !isOpen(this);
	}
}

bool opensThis(CBlob@ this, CBlob@ blob)
{
	return (blob.getTeamNum() != this.getTeamNum() &&
			!isOpen(this) && blob.isCollidable() &&
			( blob.hasTag("player") || blob.hasTag("vehicle")));
}

void onCollision( CBlob@ this, CBlob@ blob, bool solid )
{
    if (blob !is null)
    {
        if ( opensThis(this,blob) )
        {
            setOpen(this, true);
        }
    }
}

void onEndCollision( CBlob@ this, CBlob@ blob )
{
	if (blob !is null)
	{
		bool touching = false;
		const uint count = this.getTouchingCount();
		for (uint step = 0; step < count; ++step)
		{
			CBlob@ blob = this.getTouchingByIndex(step);
			if (blob.isCollidable()) {
				touching = true;
				break;
			}
		}

		if (!touching)
		{
			setOpen(this, false);
		}
	}
}


bool canBePickedUp( CBlob@ this, CBlob@ byBlob )
{
    return false;
}
