#include "Vehicle.as"

// Boat logic

void onInit(CBlob@ this )
{
    Vehicle_Setup( this,
                   160.0f, // move speed
                   0.31f,  // turn speed
                   Vec2f(0.0f, -5.0f), // jump out velocity
                   true  // inventory access
                 );
    Vehicle_SetupWaterSound( this,  "BoatRowing", // movement sound
                             0.0f, // movement sound volume modifier   0.0f = no manipulation
                             0.0f // movement sound pitch modifier     0.0f = no manipulation
                           );
    this.getShape().SetOffset(Vec2f(0,9));
    this.getShape().SetCenterOfMassOffset(Vec2f(-1.5f,4.5f));
	this.getShape().getConsts().transports = true;
    // override icon
    AddIconToken( "$"+this.getName()+"$", CFileMatcher("VehicleIcons.png").getFirst(), Vec2f(32,32), 2 );
}

void onTick( CBlob@ this )
{
    Vehicle_Update( this );
    Vehicle_StandardControls( this );
}

void Vehicle_onFire( CBlob@ this, CBlob@ bullet, const u8 charge ) {}
bool Vehicle_canFire( CBlob@ this , bool isActionPressed, bool wasActionPressed, u8 &out chargeValue ) {return false;}

bool doesCollideWithBlob( CBlob@ this, CBlob@ blob )
{
	return Vehicle_doesCollideWithBlob_boat( this, blob );	
}
