#include "Vehicle.as"

// Boat logic

void onInit(CBlob@ this )
{
	Vehicle_Setup( this,
                   135.0f, // move speed
                   0.19f,  // turn speed
                   Vec2f(0.0f, -5.0f), // jump out velocity
                   true  // inventory access
                 );
    Vehicle_SetupWaterSound( this,  "BoatRowing", // movement sound
                             0.0f, // movement sound volume modifier   0.0f = no manipulation
                             0.0f // movement sound pitch modifier     0.0f = no manipulation
                           );
    
	Vec2f pos_off(0,0);
                           
    this.getShape().SetOffset(Vec2f(-6,20));

    this.getShape().getConsts().bullet = true;
    
    AttachmentPoint@[] aps;
    if (this.getAttachmentPoints( @aps ))
    {
        for (uint i = 0; i < aps.length; i++)
        {
            AttachmentPoint@ ap = aps[i];
            ap.offsetZ = 10.0f;
		}
	}
    
	this.getShape().getConsts().transports = true;
    
	// additional shapes

	{
		Vec2f[] shape = { Vec2f( 39.0f,  4.0f ) -pos_off,
						  Vec2f( 67.0f,  4.0f ) -pos_off,
						  Vec2f( 73.0f,  7.0f ) -pos_off,
						  Vec2f( 48.0f,  7.0f ) -pos_off };
		this.getShape().AddShape( shape );
	}

	{
		Vec2f[] shape = { Vec2f( 69.0f,  7.0f ) -pos_off,
						  Vec2f( 73.0f,  7.0f ) -pos_off,
						  Vec2f( 73.0f,  24.0f ) -pos_off,
						  Vec2f( 69.0f,  24.0f ) -pos_off };
		this.getShape().AddShape( shape );
	}
	
	{
		Vec2f[] shape = { Vec2f( 69.0f,  23.0f ) -pos_off,
						  Vec2f( 93.0f,  31.0f ) -pos_off,
						  Vec2f( 79.0f,  43.0f ) -pos_off,
						  Vec2f( 69.0f,  45.0f ) -pos_off };
		this.getShape().AddShape( shape );
	}
	
	//{
	//	Vec2f[] shape = { Vec2f( 2.0f,  24.0f ) -pos_off,
	//					  Vec2f( 49.0f, 24.0f ) -pos_off,
	//					  Vec2f( 49.0f, 26.0f ) -pos_off,
	//					  Vec2f( 3.0f,  26.0f ) -pos_off };
	//	this.getShape().AddShape( shape );
	//}
	
	{
		Vec2f[] shape = { Vec2f( 4.0f,  26.0f ) -pos_off,
						  Vec2f( 15.0f, 26.0f ) -pos_off,
						  Vec2f( 15.0f, 42.0f ) -pos_off,
						  Vec2f( 11.0f, 42.0f ) -pos_off };
		this.getShape().AddShape( shape );
	}
	
	CSprite@ sprite = this.getSprite();
	CSpriteLayer@ front = sprite.addSpriteLayer( "front layer", sprite.getConsts().filename, 96, 56 );
	if (front !is null)
	{
		front.addAnimation("default",0,false);
		int[] frames = { 0 };
		front.animation.AddFrames(frames);
		front.SetRelativeZ(55.0f);
	}
	
	CSpriteLayer@ flag = sprite.addSpriteLayer( "flag", sprite.getConsts().filename, 32, 56 );
	if (flag !is null)
	{
		flag.addAnimation("default",3,true);
		int[] frames = { 6,5,4 };
		flag.animation.AddFrames(frames);
		flag.SetRelativeZ(-5.0f);
		flag.SetOffset(Vec2f(28,-24));
	}
	
	this.set_f32("oar offset", 60.0f);
}

void onTick( CBlob@ this )
{
	Vehicle_Update( this );
    Vehicle_StandardControls( this );
	Vehicle_DontRotateInWater( this );
	//this.AddForce( Vec2f(-500.0f,0.0f));
}

void Vehicle_onFire( CBlob@ this, CBlob@ bullet, const u8 charge ) {}
bool Vehicle_canFire( CBlob@ this , bool isActionPressed, bool wasActionPressed, u8 &out chargeValue ) {return false;}

bool doesCollideWithBlob( CBlob@ this, CBlob@ blob )
{
	return Vehicle_doesCollideWithBlob_boat( this, blob );
}			 

bool canBePickedUp( CBlob@ this, CBlob@ byBlob )
{
	return false;
}

void onTick( CSprite@ this )
{
	this.SetZ(-50.0f);
}
