//Rock logic

#include "/Entities/Common/Attacks/Hitters.as";

const f32 ROCK_DAMAGE = 0.5f;

//sprite functions
void onInit( CSprite@ this )
{
    //set a random frame
    Animation@ anim = this.addAnimation("Rock",0,false);
    anim.AddFrame(this.getBlob().getNetworkID()%4);
    this.SetAnimation(anim);
}

//blob functions
void onInit( CBlob@ this )
{
	this.getShape().getConsts().bullet = true;
    this.server_SetTimeToDie( 10 + Random(2) );
    this.set_f32("hit dmg modifier", 1.0f);
    this.set_f32("map dmg modifier", 300.0f);
	this.set_u8("hurtoncollide hitter", Hitters::cata_stones);
}

void onTick( CBlob@ this )
{
    if (getNet().isServer() && this.getShape().vellen < 0.05f) {
        this.server_Die();
    }

	// chew through backwalls

	CMap@ map = this.getMap();
	Vec2f pos = this.getPosition();
	TileType tile = map.getTile( pos );	 
	if (this.getShape().vellen > 3.0f && map.isTileBackgroundNonEmpty( tile ))
	{
		if (map.getSectorAtPosition( pos, "no build") !is null) {
			return;
		}
		map.server_DestroyTile( pos, 1.0f );
	}
}

void MakeDustParticle(Vec2f pos, string file )
{
	CParticle@ temp = ParticleAnimated( CFileMatcher(file).getFirst(), pos - Vec2f(0,8), Vec2f(0,0), 0.0f, 1.0f, 3, 0.0f, false );

	if (temp !is null)
	{
		temp.width = 8;
		temp.height = 8;
	}
}


void onCollision( CBlob@ this, CBlob@ blob, bool solid, Vec2f normal, Vec2f point1 )
{
	if (solid)
		MakeDustParticle( point1, "Smoke.png");
	else
	{	
		// hit non-collidable
		if (blob.getTeamNum() != this.getTeamNum() && !blob.hasTag("invincible"))		
		{
			this.server_Hit( blob, point1, this.getVelocity(), this.getShape().vellen*0.1f, Hitters::cata_stones, true);
		}
	}
}
