#include "Hitters.as";

void onCollision( CBlob@ this, CBlob@ blob, bool solid, Vec2f normal, Vec2f point1 )
{
	//if (blob !is null)
	//	printf("col with " + blob.getName() + " vel " + this.getShape().vellen );

	const f32 vellen = this.getShape().vellen;
	if (blob !is null && vellen > 0.5f && blob.hasTag("player"))
	{
		Vec2f pos = this.getPosition();
		Vec2f vel = this.getVelocity();
		Vec2f other_pos = blob.getPosition();
		Vec2f direction = other_pos - pos;		
		direction.Normalize();
		vel.Normalize();
		if (vel * direction > 0.33f)
		{
			this.server_Hit( blob, point1, vel, vellen, Hitters::flying, false);
		}
	}
}

void onHitBlob( CBlob@ this, Vec2f worldPoint, Vec2f velocity, f32 damage, CBlob@ hitBlob, u8 customData )
{
	if (hitBlob !is null && customData == Hitters::flying)
	{
		hitBlob.AddForce( velocity * this.getMass() * 0.15f );
	}
}