#include "SeatsCommon.as"
#include "Help.as";

void onInit( CBlob@ this )
{
    AttachmentPoint@[] aps;

    if (this.getAttachmentPoints( @aps ))
    {
        for (uint i = 0; i < aps.length; i++)
        {
            InitSeatAttachment( aps[i] );
        }
    }

    this.Tag("seats");

	SetHelp( this, "help hop", "", "Hop inside   \n\n         $KEY_S$" );
}

void onAttach( CBlob@ this, CBlob@ attached, AttachmentPoint @attachedPoint )
{
    if (attachedPoint.socket)
    {
        SetOccupied( attachedPoint, 1 );
        attached.Tag( "seated" );
        Sound::Play( "GetInVehicle.ogg", attached.getPosition() );
    }
}

void onDetach( CBlob@ this, CBlob@ detached, AttachmentPoint@ attachedPoint )
{
    if (attachedPoint.socket)
    {
        SetOccupied( attachedPoint, 0 );
        detached.Untag( "seated" );

        if (!detached.getShape().isRotationsAllowed()) {
            detached.setAngleDegrees(0.0f);
        }
    }
}

void InitSeatAttachment( AttachmentPoint@ ap )
{
    if (ap !is null && ap.socket)
    {
        ap.offsetZ = -10.0f;
        ap.SetKeysToTake( key_left | key_right | key_up | key_down | key_action1 | key_action2 | key_action3 );
        ap.SetMouseTaken( true );
        ap.customData = 0;

        if (ap.name == "DRIVER") {
            ap.controller = true;								// client-side movement
        }
    }
}