#include "SeatsCommon.as"

// optimization: we use script globals here cause all seats GUI use the same value for this
 f32 bounce;
 u32 lastBounceTime;

 void onInit( CSprite@ this )
 {
	 this.getCurrentScript().runFlags |= Script::tick_not_attached;
 }

void onRender( CSprite@ this )
{
	if (this is null) return; //can happen with bad reload
	
    // draw only for local player
    CBlob@ localBlob = getLocalPlayerBlob();

    if (localBlob is null || localBlob.isAttached()) {
        return;
    }
	CBlob@ blob = this.getBlob();

    f32 arrowVisibleRadius = blob.getRadius() + 15.0f;

    if ((localBlob.getPosition() - blob.getPosition()).getLength() > arrowVisibleRadius) {
        return;
    }

    // dont draw if angle is upside down
    f32 angle = blob.getAngleDegrees();

    if (angle > 70.0f && angle < 290.0f) {
        return;
    }

    // draw arrows pointing towards seats
	if (lastBounceTime != getGameTime())
	{
		bounce = Maths::Sin( (getGameTime() + blob.getNetworkID()) / 4.5f );
		lastBounceTime = getGameTime();
	}

    if (bounce > 0.4f) {
        return;
    }

    AttachmentPoint@[] aps;

    if (blob.getAttachmentPoints( @aps ))
    {
		string lastPointName;
        for (uint i = 0; i < aps.length; i++)
        {
            AttachmentPoint@ ap = aps[i];

            if (ap.getOccupied() is null && ap.socket && ap.radius > 0.0f && lastPointName != ap.name) // gather empty controllers attachments/seats
            {
                int occupied = ap.customData;
				const bool driver = ap.name == "DRIVER";  // HACK:
                if (occupied == 0 && (!driver || (driver && !blob.isAttached())))
                {
                    Vec2f pos = getDriver().getScreenPosFromWorldPos( ap.getPosition() );
                    pos.y += -3.0f + 10.0f * bounce;
					if (blob.isFacingLeft())
					{
						pos.x -= 8.0f;
					}
                    GUI::DrawIcon( "GUI/ArrowDown_.png", pos );

					lastPointName = ap.name;  // draw just one of a kind
                }
            }
        }
    }
}
