/*
 * convertible if enemy take it
 */
 
void onInit(CBlob@ this)
{
	this.addCommandID("convert");
}

void onAttach( CBlob@ this, CBlob@ attached, AttachmentPoint @attachedPoint )
{
	checkConvert(this);
}

void onDetach( CBlob@ this, CBlob@ attached, AttachmentPoint @attachedPoint )
{
	checkConvert(this);
}

void checkConvert(CBlob@ this)
{
	int convertTeam, currentTeam;
	int team = this.getTeamNum();
	
	bool shouldconvert = false;
	bool canconvert = true;
	
	AttachmentPoint@[] aps;
	if (this.getAttachmentPoints( @aps ))
    {
        for (uint i = 0; i < aps.length; i++)
        {
            AttachmentPoint@ ap = aps[i];
            CBlob@ b = ap.getOccupied();
            
            if(b !is null)
            {
				//convert only by players
				if ( !b.hasTag("player") ) continue;
				
				//compare teams
				currentTeam = b.getTeamNum();
				bool sameTeam = (currentTeam == team);
				if (sameTeam)
				{
					canconvert = false;
					break;
				}
				else if (!shouldconvert)
				{
					convertTeam = currentTeam;
					shouldconvert = true;
				}
				
			}
		}
	}
	
	if (canconvert && shouldconvert)
	{
		CBitStream bt;
		bt.write_u8( u8(convertTeam) );
		this.SendCommand( this.getCommandID("convert"), bt );
	}
}

void onCommand( CBlob@ this, u8 cmd, CBitStream @params )
{
    if (cmd == this.getCommandID("convert"))
    {
        this.setTeamNum(params.read_u8());
        CSprite@ sprite = this.getSprite();
        if (sprite !is null)
		{
			sprite.ReloadSprites(this.getTeamNum(), this.getSkinNum());
			sprite.PlaySound("/VehicleCapture");
		}
    }
}

