// Technologies for WAR

void onInit( CRules@ this )
{
    for (int i = 0; i < this.getTeamsCount(); i++)
    {
        CTechTree @tree = this.getTeam(i).techtree;
        //Core Econ
        {
            CTechnology @tech = tree.addTech( "Carpentry", 40, 8 );
            tree.setDescription("Carpentry", "Allows the production of wood structures and items.");
        }
        {
            CTechnology @tech = tree.addTech( "Masonry", 40, 16 );
            tech.AddPrereq("Carpentry");
            tree.setDescription("Masonry", "Allows the production of stone structures and items.");
        }
        {
            CTechnology @tech = tree.addTech( "Blacksmithing", 40, 16 );
            tech.AddPrereq("Masonry");
            tree.setDescription("Blacksmithing", "Allows the production of metal structures and items.");
        }
        //Farming
        {
            CTechnology @tech = tree.addTech( "Improved Farming", 120, 0 );
            tech.AddPrereq("Carpentry");
            tree.setDescription("Improved Farming", "Allows the planting of higher value crops.");
        }
        //Mechanics and lockmaking
        {
            CTechnology @tech = tree.addTech( "Mechanics", 40, 11 );
            tech.AddPrereq("Masonry");
            tree.setDescription("Mechanics", "Allows the construction of machines.");
        }
        {
            CTechnology @tech = tree.addTech( "Lockmaking", 40, 2 );
            tech.AddPrereq("Mechanics");
            tree.setDescription("Lockmaking", "Allows things to be locked to prevent entry or meddling.");
        }
        //Boats
        {
            CTechnology @tech = tree.addTech( "Naval Engineering", 40, 2 );
            tech.AddPrereq("Carpentry");
            tree.setDescription("Naval Engineering", "Technology for the construction of boats.");
        }
        //Trade
        {
            CTechnology @tech = tree.addTech( "Improved Trade", 120, 0 );
            tree.setDescription("Improved Trade", "Nets you better import and export prices.");
        }
        //Guilds
        {
            CTechnology @tech = tree.addTech( "Guilds", 180, 0 );
            tech.AddPrereq("Carpentry");
            tech.AddPrereq("Masonry");
            tech.AddPrereq("Improved Trade");
            tree.setDescription("Guilds", "Associations of craftspeople.\nImproves organisation, boosting construction speed and export sales.");
        }
        //Military
        {
            CTechnology @tech = tree.addTech( "Infantry Warfare", 40, 11 );
            tech.AddPrereq("Carpentry");
            tree.setDescription("Infantry Warfare", "Allows the construction of armouries and archery ranges.");
        }
        {
            CTechnology @tech = tree.addTech( "Pyrotechnics", 40, 11 );
            tech.AddPrereq("Masonry");
            tree.setDescription("Pyrotechnics", "Imported gunpowder and other flammables for explosive munitions.");
        }
        {
            CTechnology @tech = tree.addTech( "Siege Warfare", 40, 11 );
            tech.AddPrereq("Mechanics");
            tree.setDescription("Siege Warfare", "Technology for siege machines.");
        }
    }
}
