//Rules timer!

// Requires game_end_time set originally

void onInit( CRules@ this )
{
	if (!this.exists("no timer"))
		this.set_bool("no timer", false);
}

void onTick( CRules@ this )
{
    if (!getNet().isServer() || !this.isMatchRunning() || this.get_bool("no timer")) {
        return;
    }

    s32 gameEndTime = 0;
    this.get("game_end_time", gameEndTime);
    s32 timeToEnd = gameEndTime - getGameTime();

    if (timeToEnd <= 0)
    {
        bool hasWinner = false;
        s8 teamWonNumber = -1;

        if (this.exists("team_wins_on_end"))
        {
            teamWonNumber = this.get_s8("team_wins_on_end");
        }

        if (teamWonNumber >= 0)
        {
            this.SetTeamWon( teamWonNumber ); //ends the game and sets the winning team
            CTeam@ teamWon = this.getTeam(teamWonNumber);

            if (teamWon !is null)
            {
                hasWinner = true;
                this.SetGlobalMessage( "Time is up!\n" + teamWon.getName() + " wins the game!" );
            }
        }

        if (!hasWinner)
        {
            this.SetGlobalMessage( "Time is up!\nIt's a tie!" );
        }

        this.SetCurrentState(3);
    }
}

void onRender( CRules@ this )
{
    s32 gameEndTime = 0;
    this.get("game_end_time", gameEndTime);
    s32 timeToEnd = (gameEndTime - getGameTime())/30;

    if (timeToEnd > 0 && this.isMatchRunning())
    {
        s32 secondsToEnd = timeToEnd % 60;
        s32 MinutesToEnd = timeToEnd / 60;
        drawRulesFont("Time left: "+((MinutesToEnd<10)?"0"+MinutesToEnd:""+MinutesToEnd)+":"+((secondsToEnd<10)?"0"+secondsToEnd:""+secondsToEnd),
                      SColor(255,255,255,255), Vec2f(10,140), Vec2f(getScreenWidth()-20,180), true, false);
    }
}
