// Player spawning/management for Sandbox

#define SERVER_ONLY

void onRestart(CRules@ this)
{
    //spawn spawns :D
    CMap@ map = getMap();

    if (map !is null)
    {
        server_CreateBlob( "Entities/Special/Tent/Tent.cfg", 0, Vec2f(150.0f, map.getLandYAtX(150.0f/map.tilesize)*map.tilesize - 32.0f) );
        server_CreateBlob( "Entities/Special/Tent/Tent.cfg", 1, Vec2f(map.tilemapwidth*map.tilesize - 150.0f, map.getLandYAtX(map.tilemapwidth - (150.0f/map.tilesize))*map.tilesize- 32.0f) );
    }
}

void onTick( CRules@ this )
{
    CBlob@[] tents;

    if (!getBlobsByName( "tent", @tents )) {
        onRestart(this);
    }
}

void StandardRespawn( CRules@ this, CPlayer@ player )
{
    if (this.getTeamsCount() == 0)
    {
        warn("There are no teams defined in game rules!");
        return;
    }

    if (player.getTeamNum() == this.getSpectatorTeamNum()) {
        return;
    }

    // RESPAWN
    // gather all tents and select assigned team's tent
    CBlob@ tent;
    CBlob@[] tents;
    getBlobsByName( "tent", @tents );

    for (uint i=0; i < tents.length; i++)
    {
        CBlob@ blob = tents[i];

        if (blob.getTeamNum() == player.getTeamNum())
        {
            @tent = blob;
            break;
        }
    }

    if (tent is null)
    {
        if (tents.length == 0) {
            warn("No tents to spawn found");
        }
        else {
            warn("Team tent not found for spawn");
        }

        return;
    }

    // respawn on a blob that is a respawn point
    string factory, config;

    if (player.lastBlobFactory.length() > 0) // if already spawned - pick last spawned config
    {
        factory = player.lastBlobFactory;
        config = player.lastBlobConfig;
    }
    else
    {
        factory = "generic";
        config = "Entities/Characters/Builder/Builder.cfg";
    }

    CRespawnQueueActor @queue = getRespawn().QueueOnBlob( player, player.getTeamNum(), factory, config, this.playerrespawn_seconds, tent );
    queue.skin = 5;
}

// player requests spawn on joining game and when switching teams
void onPlayerRequestSpawn( CRules@ this, CPlayer@ player )
{
    //if (player.getTeamNum() < 0 || player.getTeamNum() > this.getSpectatorTeamNum()) {
    //    player.ChangeTeam(0);
    //}

    StandardRespawn(this,player);
}

