#include "TDM_Structs.as";

/*
void onTick( CRules@ this )
{
    //see the logic script for this
}
*/

void onInit( CRules@ this )
{
    CBitStream stream;
    stream.write_u16(0xDEAD);
    this.set_CBitStream("tdm_serialised_team_hud", stream);
}

void onRender( CRules@ this )
{
    CPlayer@ p = getLocalPlayer();

    if (p is null || !p.isMyPlayer()) { return; }

    CBitStream serialised_team_hud;
    this.get_CBitStream("tdm_serialised_team_hud", serialised_team_hud);

    if (serialised_team_hud.getBytesUsed() > 10)
    {
        serialised_team_hud.Reset();
        u16 check;

        if (serialised_team_hud.saferead_u16(check) && check == 0x5afe)
        {
            const string gui_image_fname = "Rules/TDM/TDMGui.png";

            while (!serialised_team_hud.isBufferEnd())
            {
                TDM_HUD hud(serialised_team_hud);
                Vec2f topLeft = Vec2f(8,8+64*hud.team_num);
                GUI::DrawIcon(gui_image_fname, 0, Vec2f(128,32), topLeft, 1.0f, hud.team_num);
                int team_player_count = 0;
                int team_dead_count = 0;
                int step = 0;
                Vec2f startIcons = Vec2f(64,8);
                Vec2f startSkulls = Vec2f(160, 8);
                string player_char = "";
                int size = int(hud.unit_pattern.size());

                while (step < size)
                {
                    player_char = hud.unit_pattern.substr(step,1);
                    step++;

                    if (player_char == " ") { continue; }

                    if (player_char != "s")
                    {
                        int player_frame = 1;

                        if (player_char == "a") {
                            player_frame = 2;
                        }

                        GUI::DrawIcon(gui_image_fname, 12 + player_frame, Vec2f(16,16), topLeft+startIcons+Vec2f(team_player_count*8,0) , 1.0f, hud.team_num );
                        team_player_count++;
                    }
                    else
                    {
                        GUI::DrawIcon(gui_image_fname, 12 , Vec2f(16,16), topLeft+startSkulls+Vec2f( team_dead_count*16,0) , 1.0f, hud.team_num );
                        team_dead_count++;
                    }
                }

                if (hud.spawn_time != 255)
                {
                    string time = ""+hud.spawn_time;
                    GUI::DrawText(time, topLeft + Vec2f(196,42), SColor(255,255,255,255));
                }

                string kills = "WARMUP";

                if (hud.kills_limit > 0)
                {
                    kills = "KILLS: "+hud.kills+"/"+hud.kills_limit;
                }

                GUI::DrawText(kills, topLeft+Vec2f(64,42), SColor(255,255,255,255));
            }
        }

        serialised_team_hud.Reset();
    }

    string propname = "tdm spawn time "+p.getUsername();	
    if (p.getBlob() is null && this.exists(propname) )
    {
        u8 spawn = this.get_u8(propname);

        if (spawn != 255)
        {
            if (spawn == 254)
            {
                GUI::DrawText( "In Queue to Respawn..." , Vec2f( getScreenWidth()/2 - 70, getScreenHeight()/3 + Maths::Sin(getGameTime() / 3.0f) * 5.0f ), SColor(255, 255, 255, 55) );
            }
            else
            {
                GUI::DrawText( "Respawn in: "+spawn , Vec2f( getScreenWidth()/2 - 70, getScreenHeight()/3 + Maths::Sin(getGameTime() / 3.0f) * 5.0f ), SColor(255, 255, 255, 55) );
            }
        }
    }
}
