#include "WAR_Structs.as";
#include "WAR_HUDCommon.as";

#include "TeamColour.as";

//HUD serialisation done in the logic script now

const string WarGUITexture = "Rules/WAR/WarGUI.png";

void onRender( CRules@ this )
{
    CPlayer@ p = getLocalPlayer();

    if (p is null || !p.isMyPlayer() ) { return; }

	//hud from rules bitstream
	CBitStream stream;
	this.get_CBitStream("WAR_serialised_team_hud", stream);
	
	u16 checkbits;
	if (stream.getBitsUsed() > 0 && stream.saferead_u16(checkbits) && checkbits == 0x54f3)
	{
		Vec2f upperleft( 10, 10 );
		while(!stream.isBufferEnd())
		{
			WAR_HUD hud(stream);
			
			Vec2f mycorner = upperleft + Vec2f( 0, hud.team_num * 16 );
			
			CTeam@ team = this.getTeam(hud.team_num);
			if (team is null) continue;
			
			GUI::DrawText( team.getName(), mycorner, mycorner + Vec2f(100,10), getTeamColor(hud.team_num), true, true );
			
			//attacked
			if (hud.under_raid && (getGameTime() % 30) > 15)
			{
				GUI::DrawText( "UNDER ATTACK",
								mycorner+Vec2f(100,0), mycorner + Vec2f(250,10),
								SColor(0xffff4444), true, true );
			}
			else
			{
				GUI::DrawText( ""+hud.num_alive+" Alive / "+hud.num_units+" Total",
								mycorner + Vec2f(100,0), mycorner + Vec2f(250,10),
								SColor(0xffffffff), true, true );
			}

			
		}
	}

    //respawn text if needed
    string propname = "needs respawn hud "+p.getUsername();

    if (p.getBlob() is null && this.get_bool(propname) )
    {
        propname = "time to spawn "+p.getUsername();
        s32 spawn_time = this.get_s32(propname);
        f32 difference = (f32( spawn_time - getGameTime() ) / 30.0f);

        if (difference > 0)
        {
            GUI::DrawText( "Respawning in: "+Maths::Ceil(difference) ,
								Vec2f( getScreenWidth()/2 - 70, getScreenHeight()*(0.3f) + Maths::Sin(getGameTime() / 3.0f) * 5.0f ),
								Vec2f( getScreenWidth()/2 + 70, getScreenHeight()*(0.3f) + Maths::Sin(getGameTime() / 3.0f) * 5.0f + 30),
								SColor(0xffffff00), true, true );
        }
    }
}

