#include "WAR_PopulateSpawnList.as"

const int BUTTON_SIZE = 2;

void onInit( CRules@ this )
{
    this.addCommandID("pick base");
    this.addCommandID("pick spawn");
}

// local player requests a spawn right after death

void onPlayerDie( CRules@ this, CPlayer@ victim, CPlayer@ killer, u8 customData )
{
    //if (victim !is null) {
    //    print("DEBUG: onPlayerDie - v " + (victim !is null) + " vm " + (victim.isMyPlayer()) );
    //}
    //else {
    //    print("DEBUG: onPlayerDie - v " + (victim !is null) );
    //}

    if (victim !is null && victim.isMyPlayer())
    {
        if (victim.getBlob() !is null) {
            victim.getBlob().ClearMenus();
        }

        // find trading posts that aren't base ones
        u16[] respawns;
        PopulateSpawnList( @respawns, victim );

        // if there are no posts just respawn

        if (respawns.length == 0)
        {
          //  print("DEBUG: client_RequestSpawn");
            victim.client_RequestSpawn();
            return;
        }

        CGridMenu@ oldmenu = getGridMenuByName("Pick spawn point");

        if (oldmenu !is null) {
            oldmenu.kill = true;
        }

        // color team icons
        AddIconToken( "$SPAWN_AT_BASE$", "WAR/SpawnIcons.png", Vec2f(48, 48), 0, victim.getTeamNum() );
        AddIconToken( "$SPAWN_AT_POST$", "WAR/SpawnIcons.png", Vec2f(48, 48), 1, victim.getTeamNum() );
        // build menu for spawns
        CGridMenu@ menu = CreateGridMenu( getDriver().getScreenCenterPos() +Vec2f(0.0f, 120.0f), null, Vec2f( (1 + respawns.length)*BUTTON_SIZE, BUTTON_SIZE), "Pick spawn point" );

        if (menu !is null)
        {
            menu.modal = true;
            CBitStream baseButtonParams;
            baseButtonParams.write_u16( getLocalPlayer().getNetworkID() );
            baseButtonParams.write_u8(0);
            CGridButton@ button =  menu.AddButton( "$SPAWN_AT_BASE$", "Spawn at edge", this.getCommandID("pick base"), Vec2f(BUTTON_SIZE, BUTTON_SIZE), baseButtonParams );
            CBitStream params;
         //   print("DEBUG: SPAWN_AT_BASE");

            for (uint i=0; i < respawns.length; i++)
            {
                params.ResetBitIndex();
                params.write_u16( getLocalPlayer().getNetworkID() );
                params.write_u8(i+1);
                CGridButton@ button2 = menu.AddButton( "$SPAWN_AT_POST$", "Spawn in " + "barracks", this.getCommandID("pick spawn"), Vec2f(BUTTON_SIZE, BUTTON_SIZE), params );
            }

            // default behaviour on clicking anywhere else
            if (respawns.length > 0) {
                menu.SetDefaultCommand( this.getCommandID("pick spawn"), params );
            }
            else {
                menu.SetDefaultCommand( this.getCommandID("pick base"), baseButtonParams );
            }
        }
    }
}

void ReadPickCmd( CRules@ this, CBitStream @params )
{
    CPlayer@ player = getPlayerByNetworkId( params.read_u16() );
    u8 pick = params.read_u8();

    if (player is getLocalPlayer())
    {
        player.client_RequestSpawn( pick );
        CGridMenu@ menu = getGridMenuByName("Pick spawn point");

        if (menu !is null) {
            menu.kill = true;
        }
    }
}

void onCommand( CRules@ this, u8 cmd, CBitStream @params )
{
    if (cmd == this.getCommandID("pick base") || cmd == this.getCommandID("pick spawn"))
    {
        ReadPickCmd( this, params );
    }
}
