// management structs

#include "Rules/CommonScripts/BaseTeamInfo.as";
#include "Rules/CommonScripts/PlayerInfo.as";

shared class WarPlayerInfo : PlayerInfo
{
    u8 spawnpoint;
    u8 wave_delay;
    f32 deathDistanceToBase;
	bool suicide;

    WarPlayerInfo() { Setup( "", 0, "" ); }
    WarPlayerInfo(string _name, u8 _team, string _default_config ) { Setup( _name, _team, _default_config ); }

    void Setup( string _name, u8 _team, string _default_config )
    {
        PlayerInfo::Setup(_name,_team,_default_config);
        spawnpoint = 0;
        wave_delay = 0;
        deathDistanceToBase = -1.0f;
        suicide = false;
    }
};

//teams

shared class WarTeamInfo : BaseTeamInfo
{
    u32 endgame_start;
    PlayerInfo@[] respawns;
    
    bool under_raid;

    u16 base_id;

    WarTeamInfo() { super(); }

    WarTeamInfo(u8 _index, string _name)
    {
        super(_index, _name);
    }

    void Reset()
    {
        BaseTeamInfo::Reset();
        //respawns.clear();
        base_id = 0;
        endgame_start = 0;
		under_raid = false;
    }
};
