// PNG loader base class - extend this to add your own PNG loading functionality!

#include "BasePNGLoader.as";

#include "MakeScroll.as";


const SColor color_tradingpost_1(0xff8888ff);
const SColor color_tradingpost_2(0xffff8888);

const SColor color_blue_team_scroll(0xff000088);
const SColor color_red_team_scroll (0xff880000);

const SColor color_crappy_scroll (0xff563d56);
const SColor color_medium_scroll (0xff9a419b);
const SColor color_super_scroll  (0xffcf31d1);

enum Offset {
	blue_team_scroll = offsets_count,
	red_team_scroll,
	
	crap_scroll,
	medium_scroll,
	super_scroll,
	
	war_offsets_count
};
   

//the loader

class WarPNGLoader : PNGLoader
{
	
	WarPNGLoader()
	{
		super();
		
		scrolls_Setup();
		
		//add missing offset arrays
		int count = war_offsets_count - offsets_count;
		while (count --> 0)
		{
			offsets.push_back(array<int>(0));
		}
	}
	
	//override this to extend functionality per-pixel.
	void handlePixel(SColor pixel, int offset)
	{
		PNGLoader::handlePixel(pixel, offset);
		
		// TRADING POST
		if (pixel == color_tradingpost_1)
		{
			spawnBlob( map, "tradingpost", offset, 0 );
			offsets[autotile_offset].push_back( offset );
		}
		else if (pixel == color_tradingpost_2)
		{
			spawnBlob( map, "tradingpost", offset, 1 );
			offsets[autotile_offset].push_back( offset );
		}
		//random scroll per-team
		else if (pixel == color_blue_team_scroll)
		{
			offsets[blue_team_scroll].push_back( offset );
			offsets[autotile_offset].push_back( offset );
		}
		else if (pixel == color_red_team_scroll)
		{
			offsets[red_team_scroll].push_back( offset );
			offsets[autotile_offset].push_back( offset );
		}
		//generic random scrolls
		else if (pixel == color_crappy_scroll)
		{
			offsets[crap_scroll].push_back( offset );
			offsets[autotile_offset].push_back( offset );
		}
		else if (pixel == color_medium_scroll)
		{
			offsets[medium_scroll].push_back( offset );
			offsets[autotile_offset].push_back( offset );
		}
		else if (pixel == color_super_scroll)
		{
			offsets[super_scroll].push_back( offset );
			offsets[autotile_offset].push_back( offset );
		}
		
	}
	
	//override this to add post-load offset types.
	void handleOffset(int type, int offset, int position, int count)
	{
		PNGLoader::handleOffset(type, offset, position, count);
		
		const Vec2f pos = getSpawnPosition(map, offset);
		if (type >= blue_team_scroll && type <= red_team_scroll)
		{
			if ( (((getGameTime() + type) * 997) % count == position) )
			{
				int index = Random(medium_scrolls_names.length);
				string defname = medium_scrolls_names[index];
				ScrollDef@ def;
				//print("defname " + index + " " + medium_scrolls_names.length + " " +defname );
				medium_scrolls.get(defname, @def);
				server_MakeTechScroll( pos, def.name, def.techs );
			}
		}
		else if (type >= crap_scroll && type <= super_scroll)
		{
			if ( Random(512) > 128 )
			{
				//TODO: pick crappy and super scroll
				string defname = "";
				switch (type)
				{
				case crap_scroll:
					defname = crappy_scrolls_names[Random(crappy_scrolls_names.length)];
					break;
				case medium_scroll:
					defname = medium_scrolls_names[Random(medium_scrolls_names.length)];
				break;
				case super_scroll:
					defname = super_scrolls_names[Random(super_scrolls_names.length)];
					break;
				}
				ScrollDef@ def;
				print("all_scrolls" + defname );
				all_scrolls.get(defname, @def);
				if (def.techs.length > 0)
					server_MakeTechScroll( pos, def.name, def.techs );
				else												  
					server_MakeScriptScroll( pos, def.name, def.scripts );
			}
		}
	}
}

